<?php
namespace App\Controller\Admin;
use App\Controller\Admin\Component\ImgComponent;

use App\Controller\Admin\AppController;
use Cake\Event\Event;
use Cake\ORM\TableRegistry;
use Cake\Core\Configure;
use Cake\I18n\Time;
use Cake\View\Helper\TimeHelper;
use Cake\Datasource\ConnectionManager;
/******************************************************************************
*File Name:	 Controller
*Creation Date: [11-02-2016]
*Modification Date: [11-02-2016]
*Author: [Raushan Suri]
*Author: [Modified By Raushan Suri]
*Description: [This controller consist of function related to Department.]
******************************************************************************/
class ProductsController extends AppController
{

    public function beforeFilter(Event $event)
    {
        parent::beforeFilter($event);
        $this->Auth->allow(['showprofile']);
    }

    
    /********************************************************************************
	Function Name: index
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view all member list and search.
	*********************************************************************************/
    public function index($id=null)
    {
		$this->loadModel('Users');
        $layoutTitle = 'Labor Dispatch :: Manage Product';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        $limit = 30;//Configure::read('App.adminPageLimit');
        $usersList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName']])
                        ->where(['Users.role' => 'Member'])->order(['Users.fullName'=>'ASC'])->toArray();
        $this->paginate = [
            'limit' => $limit,
            'order' => [
                'Products.created' => 'DESC'
            ],
			//'contain'=>['Categories', 'Subcategories']
        ];        
        $keyword = $this->request->query('keyword');
		$USERID = $this->request->query('userId');
		$condition[] = '';
        if($keyword != ''){
			$condition[] = [
				'OR' => [
					["Products.productName LIKE '%".$keyword."%'"],
					["Products.price LIKE '%".$keyword."%'"],
					//["Categories.name LIKE '%".$keyword."%'"],
					["Products.quantity LIKE '%".$keyword."%'"],
					//["Products.shippingAmount LIKE '%".$keyword."%'"],
				]				
			];
		}
		if($USERID !=''){
			$condition[] = ['Products.userId'=>$USERID];
		}
        $query = $this->Products->find('all')->where($condition);       
        $products = $this->paginate($query);
        $products = $products->toArray();
		//pr($products);die;
        $this->set(compact('products', 'limit', 'usersList'));
    }

      
    /********************************************************************************
	Function Name: add
	*Type: Public function used as action of the controller
	*Input: No input
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to add hours.
	*********************************************************************************/
    public function add()
    {
		$this->loadModel('Users');
		$this->loadModel('Categories');
        $layoutTitle = 'Labor Dispatch ::  Add New Product';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
		      
//        $parentClientList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name', 'parentId']])
//						->where(['Categories.parentId'=>'0'])
//                        ->order(['Categories.name'=>'ASC'])->toArray();
//        $regex = "/;[1-9]*/";
//        $replacement = " (Sub)";
//        $fff = str_replace(";0", " (Main)", $parentClientList);
//        
//        $parentClientList = preg_replace($regex, $replacement, $fff);
//		
//		
//		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName', 'email']])
//						//->where(['Users.status'=>'0'])
//                        ->order(['Users.fullName'=>'ASC'])->toArray();
//        
//        $regex = "/;[1-9]*/";
//        $replacement = " - ";
//        $fff = str_replace(";0", " (Main)", $userList);
//        $userList = preg_replace($regex, $replacement, $fff);
		
        $products = $this->Products->newEntity();        
       
        if ($this->request->is('post')) {
            $userImage = $this->request->data['image'];	
			unset($this->request->data['image']);			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				//$users['profile_picture'] = $filename;
				$this->request->data['image'] = $filename;
			}
			$products = $this->Products->patchEntity($products, $this->request->data, ['validate' => 'customer']);            
			$products['created'] = date('Y-m-d H:i:s');
			//$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Products->save($products)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	                    
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				$this->Flash->success(__('Product added successfully.'));
				return $this->redirect(['action' => 'index']);	
			}else{
				//pr($users);die;
				$this->Flash->error(__('Unable to add new product, Please try again later.'));
			}
		}
        $this->set(compact('products','parentClientList','userList'));
    }
    
    
    
    
    /********************************************************************************
	Function Name: edit
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to edit hours.
	*********************************************************************************/
    public function edit($id)
    {
		$this->loadModel('Users');
		$this->loadModel('Categories');
        $layoutTitle = 'Labor Dispatch :: Edit Product';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');
        
//		$parentClientList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name', 'parentId']])
//						->where(['Categories.parentId'=>'0'])
//                        ->order(['Categories.name'=>'ASC'])->toArray();
//        $regex = "/;[1-9]*/";
//        $replacement = " (Sub)";
//        $fff = str_replace(";0", " (Main)", $parentClientList);
//        
//        $parentClientList = preg_replace($regex, $replacement, $fff);
//		
//		
//		$userList = $this->Users->find('list', ['keyField' => 'id', 'valueField' => ['fullName', 'email']])
//						//->where(['Users.status'=>'0'])
//                        ->order(['Users.fullName'=>'ASC'])->toArray();
//        
//        $regex = "/;[1-9]*/";
//        $replacement = " - ";
//        $fff = str_replace(";0", " (Main)", $userList);
//        $userList = preg_replace($regex, $replacement, $fff);
		
        $products = $this->Products->find()->where(['Products.id' => $id])->first();//fields name in contain[] with coma
		$subcategoryList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.parentId'=>$products->categoryId])
                        ->order(['Categories.name'=>'ASC'])->toArray();
		
        if ($this->request->is(['patch', 'post', 'put'])) {
			
			$userImage = $this->request->data['image'];	
			unset($this->request->data['image']);
			unset($products['image']);
			
			$old_data = $this->Products->get($id);            			
			if(!empty($userImage['name'])){
				$filename = time() .'_'. $userImage['name'];
				$products['image'] = $filename;
				$this->request->data['image'] = $filename;
			}
			
			$products = $this->Products->patchEntity($products, $this->request->data, ['validate' => 'customer']);
			if(!empty($filename)){				
				$oldfilename = $old_data->image;
			}	
			
			$path = WWW_ROOT . 'img/uploads/feature/original/';
			if ($this->Products->save($products)) {
				if (!empty($userImage) && $userImage['name'] != '') {
					$path = WWW_ROOT . 'img/uploads/products/';	
					@unlink(WWW_ROOT . 'img/uploads/products/'.$oldfilename);
					move_uploaded_file($userImage['tmp_name'], $path.$filename);
					@chmod($path.$filename, 0777);
				}
				$this->Flash->success(__('The product updated successfully.'));
                return $this->redirect(['action' => 'index']);
			} else {
				
				$this->Flash->error(__('Product information could not be saved. Please try again later.'));
			}
        }
        $this->set(compact('products','subcategoryList','parentClientList','userList'));
    }
    
    
    /********************************************************************************
	Function Name: delete
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to delete hours permanently.
	*********************************************************************************/
    public function delete($id = null)
    {
        $users = $this->Products->get($id);
        if ($this->Products->delete($users)) {
            $this->Flash->success(__('Product has been deleted.'));
        } else {
            $this->Flash->error(__('Product could not be deleted. Please, try again.'));
        }
        return $this->redirect(['controller' => 'Products', 'action' => 'index']);
    }
    
    
    /********************************************************************************
	Function Name: status
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to update hours status.
	*********************************************************************************/
    public function status($id){
		$users = $this->Products->get($id);
		$status = '1';
		$msg = 'activated';
		if($users->status == '1'){
			$status = '0';
			$msg = 'deactivated';
		}
		
		$articles = TableRegistry::get('Products');
		$query = $articles->query();
		$query->update()
			->set(['status' => $status])
			->where(['id' => $id])
			->execute();
		$this->Flash->success(__('Product has been '.$msg.' successfully.'));
		return $this->redirect(['controller' => 'Products', 'action' => 'index']);
	}
    
    
    /********************************************************************************
	Function Name: details
	*Type: Public function used as action of the controller
	*Input: Member id
	*Author: Raushan Suri
	*Modified By: Raushan Suri
	*Output: Function to view hours information.
	*********************************************************************************/
    public function details($id){
        $layoutTitle = 'Labor Dispatch ::  Member Details';
        $this->set(compact('layoutTitle'));
        $this->viewBuilder()->layout('Admin/admin');        
		$users = $this->Products->find()->where(['Products.id' => $id])->first();
        if(!empty($users)){
            $this->set(compact('users'));
        }else{
            $this->Flash->error(__('Member doesnot exist.'));
            return $this->redirect(['controller' => 'Products', 'action' => 'index']);
        }
	}
	
	function subcategory($id){
		$this->loadModel('Categories');
        $stateList = $this->Categories->find('list', ['keyField' => 'id', 'valueField' => ['name']])
						->where(['Categories.parentId' => $id])
                        ->order(['Categories.name'=>'ASC'])->toArray();
		$contPe = '<option value="">Sub Category</option>';
		foreach($stateList as $ksy=>$val){
			$contPe .='<option value="'.$ksy.'">'.$val.'</option>';
		}
		//echo json_encode($contPe);
		echo $contPe;
		die;	
						
	}
	
	
}