<?php
/**
 * CakePHP(tm) : Rapid Development Framework (http://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright Copyright (c) Cake Software Foundation, Inc. (http://cakefoundation.org)
 * @link      http://cakephp.org CakePHP(tm) Project
 * @since     0.2.9
 * @license   http://www.opensource.org/licenses/mit-license.php MIT License
 */
namespace App\Controller;

use Cake\Core\Configure;
use Cake\View\Helper\HtmlHelper;
use Cake\Network\Exception\NotFoundException;
use Cake\View\Exception\MissingTemplateException;
use Cake\Routing\Router;
use Cake\Auth\DefaultPasswordHasher;
use Cake\ORM\TableRegistry;
use Cake\Datasource\ConnectionManager;

use Cake\View\Helper\PaginatorHelper;
/**
 * Static content controller
 *
 * This controller will render views from Template/Pages/
 *
 * @link http://book.cakephp.org/3.0/en/controllers/pages-controller.html
 */

$req_dump = '-------------------------'.date('Y-m-d H:i:s').'---------------------';
$inputJSON = file_get_contents('php://input');
if($inputJSON){
	$input = json_decode($inputJSON, TRUE);
$req_dump .= print_r($input, TRUE);
}
$req_dump .= print_r($_POST, TRUE);
$req_dump .= print_r($_FILES, TRUE);
$fp = fopen('request.log', 'a');
fwrite($fp, $req_dump);
fclose($fp);

class ServicesController extends AppController
{
    var $profilePath 			= 'http://demo2.evirtualservices.com/labor-dispatch/site/img/uploads/users/';
				var $dashboardPath 	= 'http://demo2.evirtualservices.com/labor-dispatch/site/img/uploads/dashboard/';
				var $catPath 							= 'http://demo2.evirtualservices.com/labor-dispatch/site/img/uploads/category/';
				var $postPath 						= 'http://demo2.evirtualservices.com/labor-dispatch/site/img/uploads/post/';
				var $LearningPath 		= 'http://demo2.evirtualservices.com/labor-dispatch/site/img/uploads/learning/';
				var $baseUrl 							= 'http://demo2.evirtualservices.com/labor-dispatch/site/';
				var $productPath    = 'http://demo2.evirtualservices.com/labor-dispatch/site/img/uploads/products/';
	function index(){
		//header("Content-type:application/json");
		Configure::write('Session.checkAgent', false);
		$response=array();
		//$this->layout='';
		if($this->request->data('action') !=''){
			$this->request->data=$this->request->data;
			}else{
					$inputJSON = file_get_contents('php://input');
					if($inputJSON){
						$this->request->data = json_decode($inputJSON, TRUE);
					}
			}
			$action = trim($this->request->data['action']);
					//echo $action;
					//pr($this->request->data); die;
				if(!empty($action)){
						$response = $this->$action();
						unset($this->request->data['action']);
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'Invalid action key';
				}
				echo json_encode($response); die;
	}
    
	private function registration(){
		$this->loadModel('Users');
		if($this->request->data('email') !='' && $this->request->data('fullName') !='' && $this->request->data('contactNumber') !='' && $this->request->data('password') !=''){
			$this->loadModel('Users');
			$usr = $this->Users->find()->where(['OR'=>[['Users.email' => $this->request->data('email')],['Users.contactNumber' => $this->request->data('contactNumber')]]])->first();
			if(!empty($usr)){
				$response['status'] = 'Fails';
				$response['msg'] = 'Email or phone already registred with Labor Dispatch';
			}else{
					$this->request->data['password'] = str_replace(' ', '', $this->request->data('password'));
					$this->request->data['email'] = str_replace(' ', '', $this->request->data('email'));
					$this->request->data['Pcode'] = base64_encode($this->request->data['password']);
					$users = $this->Users->newEntity();
					$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => false]);
					$users['created'] 	= date('Y-m-d H:i:s');
					$users['username'] 	= $this->request->data('email');
					$users['status'] 	= '1';
					//$users['role'] 		= 'Member';
					$fileName = '';
					if(@$_FILES['image']['name']){
						$fileName=time().stripslashes($_FILES['image']['name']);
						$fileName= str_replace(" ","",$fileName);
						$users['profile_picture']=$fileName;
					}
					//$path = WWW_ROOT . 'img/uploads/feature/original/';
					if ($this->Users->save($users)) {
							if(@$_FILES['image']['name'] !='' && $fileName !=''){
									$target = WWW_ROOT.'/img/uploads/users/'.$fileName;
									$source=$_FILES['image']['tmp_name'];
									move_uploaded_file($source,$target);
							}
								$response['status'] = 'success';
								$response['msg'] = 'Data save successfully.';
								//@mail('raushan.kumar@evirtualservices.com', 'HELLO', 'YES test mail');
								$to=$this->request->data('email');
								//$to='raushan.kumar@evirtualservices.com';
								$subject="Labor Dispatch Registration";
								$message="Dear ".ucfirst($this->request->data('fullName'));
								$message .= '<br>Your new <strong><span style="color:#2133A1">Labor Dispatch</span> Account has been created. Welcome to the <strong><span style="color:#2133A1">Labor Dispatch</span></strong> family!';
								$message .= '<br>From now on, please log in to your account using your email address and password';
								$message .='<br><br> Thank you for registering with <strong><span style="color:#2133A1">Labor Dispatch</span>. Your credentials is given below:';
								$message .='<br>Name: '.ucfirst($this->request->data['fullName']);
								$message .='<br>Email: '.$this->request->data('email').'<br>Password: '.$this->request->data['password'];
								$this->phpemail($to, $subject, $message);
								$dd = $this->profile($users->id);
								$response['data'] = $dd['data'];
					}
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'Email, contactNumber,fullName and password required';
		}
		return  $response;
	}
	
	
	private function login($slug=NULL){
		if($this->request->data){
			//pr($this->request->data); die;
			$this->loadModel('Users');
			//$usr = $this->Users->find()->where(['Users.email' => $this->request->data('email')])->first();
			$usr = $this->Users->find()->where(['OR'=>[['Users.email' => $this->request->data('email')],['Users.contactNumber' => $this->request->data('email')]]])->first();
				if(!empty($usr)){
						$check = (new DefaultPasswordHasher)->check(trim($this->request->data('password')),$usr->password);
						if($check && $usr->status == 1){
								//$userdetail['FreedomUsers'] = $usr;
								//$this->request->session()->write($userdetail);
								$usr = $this->Users->patchEntity($usr, $this->request->data, ['validate' => false]);
								$this->Users->save($usr);
								$response['status'] = 'success';
								$response['msg'] = 'Data save successfully.';
								$RES = $this->profile($usr->id);
								$response['data'] = $RES['data'];
								//$response['data'] = $this->profile($users->id);
						}else{
								$response['status'] = 'Fails';
								$response['msg'] = 'Email or password is wrong.';
						}
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'Email or password is wrong.';
				}
		}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'Email or password is required.';
		}
			return  $response;
	}
	
	
	function profile($userId = NULL){
			$this->loadModel('Users');
			$this->loadModel('Reviews');
			$this->loadModel('Carts');
			
			@$userID = ($userId) ? $userId : $this->request->data('userId');
			
			$userD = $this->Users->find()->where(['Users.id' => $userID])->first();
			//pr($userD); die;
			if($userD){
						$UserDetail['userId'] 								= ($userD->id) ? $userD->id : '';
						$UserDetail['fullName'] 						= ($userD->fullName) ? $userD->fullName : '';
						$UserDetail['lastName'] 						= ($userD->lastName) ? $userD->lastName : '';
						$UserDetail['middleName'] 				= ($userD->middleName) ? $userD->middleName : '';
						$UserDetail['email'] 									= ($userD->email) ? $userD->email : '';
						$UserDetail['gender'] 								= ($userD->gender) ? $userD->gender : '';
						$UserDetail['role'] 										= ($userD->role) ? $userD->role : '';
						$UserDetail['dob'] 											= ($userD->dob) ? $userD->dob : '';
						$UserDetail['address'] 							= ($userD->address) ? $userD->address : '';
						$UserDetail['zipCode'] 							= ($userD->zipCode) ? $userD->zipCode : '';
						$UserDetail['state'] 									= ($userD->state) ? $userD->state : '';
						$UserDetail['country'] 							= ($userD->country) ? $userD->country :'';
						$UserDetail['contactNumber'] 	= ($userD->contactNumber) ? $userD->contactNumber :'';
						
						
						$UserDetail['latitude'] 							= ($userD->latitude) ? $userD->latitude :'';
						$UserDetail['longitude'] 						= ($userD->longitude) ? $userD->longitude :'';
						
						$UserDetail['image'] 									= ($userD->profile_picture) ? $this->profilePath.$userD->profile_picture : '';
						if(strpos($userD->profile_picture, "http") !== false){
							$UserDetail['image'] = $userD->profile_picture;
						}
						
						
						$UserDetail['ssnImage'] 									= ($userD->ssnImage) ? $this->profilePath.$userD->ssnImage : '';
						$UserDetail['AutoInsurance'] 				= ($userD->AutoInsurance) ? $this->profilePath.$userD->AutoInsurance : '';
						$UserDetail['drivlingImage'] 				= ($userD->drivlingImage) ? $this->profilePath.$userD->drivlingImage : '';
						
						$UserDetail['device'] 							= ($userD->device) ? $userD->device : '';
						$UserDetail['deviceToken'] 		= ($userD->deviceToken) ? $userD->deviceToken : '';
						$UserDetail['firebaseId'] 			= ($userD->firebaseId) ? $userD->firebaseId : '';
						$UserDetail['socialId'] 					= ($userD->socialId) ? $userD->socialId : '';
						$UserDetail['socialType'] 			= ($userD->socialType) ? $userD->socialType : '';
						
						$UserDetail['BankName'] 							= ($userD->BankName) ? $userD->BankName : '';
						$UserDetail['AccountHolderName'] 		= ($userD->AccountHolderName) ? $userD->AccountHolderName : '';
						$UserDetail['AccountNo'] 			= ($userD->AccountNo) ? $userD->AccountNo : '';
						$UserDetail['RoutingNo'] 					= ($userD->RoutingNo) ? $userD->RoutingNo : '';
						$UserDetail['accountType'] 			= ($userD->accountType) ? $userD->accountType : '';
						
						$UserDetail['Mile'] 												= ($userD->Mile) ? $userD->Mile : '';
						$UserDetail['VehicleType'] 					= ($userD->VehicleType) ? $userD->VehicleType : '';
						$UserDetail['VehicleNumber'] 			= ($userD->VehicleNumber) ? $userD->VehicleNumber : '';
						$UserDetail['VehicleMake'] 					= ($userD->VehicleMake) ? $userD->VehicleMake : '';
						$UserDetail['VehicleModle'] 				= ($userD->VehicleModle) ? $userD->VehicleModle : '';
						$UserDetail['VehicleYear'] 					= ($userD->VehicleYear) ? $userD->VehicleYear : '';
						$UserDetail['TranspotationType']= ($userD->TranspotationType) ? $userD->TranspotationType : '';
						
						$UserDetail['subscriptionDate'] 			= ($userD->subscriptionDate) ? date('Y-m-d H:i:s',strtotime($userD->subscriptionDate)) : '';
						$UserDetail['subscriptionPlan'] 			= ($userD->subscriptionPlan) ? $userD->subscriptionPlan : '';
						$UserDetail['subscriptionEnd'] 				= ($userD->subscriptionEnd) ?	date('Y-m-d',strtotime($userD->subscriptionEnd)) : '';
						$UserDetail['subscriptionStatus'] 	= (date('Y-m-d',strtotime($userD->subscriptionEnd)) >= date('Y-m-d')) ? 1 : 0;
						
						$UserDetail['wallet'] 									= ($userD->wallet) ? $userD->wallet : 0;
						
						$UserDetail['TotalCartItem'] = $this->Carts->find()->where(['Carts.userId'=>$userID])->count();
						
						$response['status'] = 'success';
						$response['data'] = $UserDetail;
			
			}else{
					$response['status'] = 'Fails';
					$response['msg'] = 'UserId required';
			}
			
			return  $response;
	}
	
	function updatesubscription(){
		if($this->request->data('userId') !='' && $this->request->data('amount') !='' && $this->request->data('days') !=''){
			$this->loadModel('Subscriptions');
							$reviews = $this->Subscriptions->newEntity();
							$reviews = $this->Subscriptions->patchEntity($reviews, $this->request->data, ['validate' => false]);
							$reviews['created'] 	= date('Y-m-d H:i:s');
							$reviews['status'] 	= '1';
							$this->Subscriptions->save($reviews);
							
							$Next_day = date("Y-m-d", strtotime("+".$this->request->data('days')." days"));
							$articles = TableRegistry::get('Users');
							$query = $articles->query();
							$query->update()
							->set(['subscriptionEnd' =>$Next_day])
							->where(['id' => $this->request->data['userId']])
							->execute();
							$response['status'] = 'success';
						$response['msg'] = 'Updated successfully.';
						
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'userId, amount and days are required.';
		}
		return  $response;
	}
	
	function socialLoginAction(){
		$this->loadModel('Users');
		if($this->request->data('email') !='' && $this->request->data('fullName') !='' && $this->request->data('socialId') !='' && $this->request->data('socialType') !=''){
			$this->loadModel('Users');
			$usr = $this->Users->find()->where(['Users.socialId' => $this->request->data('socialId'),'Users.socialType' => $this->request->data('socialType')])->first();
			$users = $this->Users->find()->where(['Users.email' => $this->request->data('email')])->first();
			if(empty($usr)){
				if(empty($users)){
					$users = $this->Users->newEntity();
				}
				$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => false]);
				$users['created'] 	= date('Y-m-d H:i:s');
				$users['username'] 	= $this->request->data('email');
				$users['status'] 	= '1';
				$users['role'] 		= 'Member';
				//$users['profile_picture'] 		= $this->request->data('image');
				
				//$path = WWW_ROOT . 'img/uploads/feature/original/';
				if ($this->Users->save($users)) {
							$response['status'] = 'success';
							$response['msg'] = 'Data save successfully.';
							$response['data'] = $this->profile($users->id);
				}
			}else{
				$response['status'] = 'success';
				$response['msg'] = 'Data save successfully.';
				$response['data'] = $this->profile($usr->id);
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'Email, fullName, socialId and socialType required';
		}
		return  $response;
	}
	
	
	private function editprofile(){
		$this->loadModel('Users');
		if($this->request->data('userId') !=''){
			$this->loadModel('Users');
			$users = $this->Users->find()->where(['Users.id' => $this->request->data('userId')])->first();
			if(!empty($users)){
				//@unset($this->request->data('email'));
				$users = $this->Users->patchEntity($users, $this->request->data, ['validate' => false]);
				$fileName = '';
				if(@$_FILES['image']['name']){
					$fileName=time().stripslashes($_FILES['image']['name']);
					$fileName= str_replace(" ","",$fileName);
					$users['profile_picture']=$fileName;
					$url = $this->profilePath.$users->profile_picture;
					@unlink($url);
				}
				$fileName2 = '';
				if(@$_FILES['ssnImage']['name']){
					$fileName2=time().stripslashes($_FILES['ssnImage']['name']);
					$fileName2= str_replace(" ","",$fileName2);
					$users['ssnImage']=$fileName2;
					$url = $this->profilePath.$users->ssnImage;
					@unlink($url);
				}
				$fileName3 = '';
				if(@$_FILES['drivlingImage']['name']){
					$fileName3=time().stripslashes($_FILES['drivlingImage']['name']);
					$fileName3= str_replace(" ","",$fileName3);
					$users['drivlingImage']=$fileName3;
					$url = $this->profilePath.$users->drivlingImage;
					@unlink($url);
				}
				$fileName4 = '';
				if(@$_FILES['AutoInsurance']['name']){
					$fileName4=time().stripslashes($_FILES['AutoInsurance']['name']);
					$fileName4= str_replace(" ","",$fileName4);
					$users['AutoInsurance']=$fileName4;
					$url = $this->profilePath.$users->AutoInsurance;
					@unlink($url);
				}
				$fileName5 = '';
				if(@$_FILES['companyBackground']['name']){
					$fileName5=time().stripslashes($_FILES['companyBackground']['name']);
					$fileName5= str_replace(" ","",$fileName5);
					$users['companyBackground']=$fileName5;
					$url = $this->profilePath.$users->companyBackground;
					@unlink($url);
				}
				//$path = WWW_ROOT . 'img/uploads/feature/original/';
				if ($this->Users->save($users)) {
						if(@$_FILES['image']['name'] !='' && $fileName !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName;
								$source=$_FILES['image']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['ssnImage']['name'] !='' && $fileName2 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName2;
								$source=$_FILES['ssnImage']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['drivlingImage']['name'] !='' && $fileName3 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName3;
								$source=$_FILES['drivlingImage']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['AutoInsurance']['name'] !='' && $fileName4 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName4;
								$source=$_FILES['AutoInsurance']['tmp_name'];
								move_uploaded_file($source,$target);
						}
						if(@$_FILES['companyBackground']['name'] !='' && $fileName5 !=''){
								$target = WWW_ROOT.'/img/uploads/users/'.$fileName5;
								$source=$_FILES['companyBackground']['tmp_name'];
								move_uploaded_file($source,$target);
						}
							$response['status'] = 'success';
							$response['msg'] = 'Data save successfully.';
							$DD = $this->profile($users->id);
							$response['data'] = $DD['data'];
				}
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'UserId does not exist';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'UserID is required';
		}
		return  $response;
	}
	
	
	function changepassword(){
		$this->loadModel('Users');
		if($this->request->data('userId')){
			$users = $this->Users->find()->Where(['Users.id' => $this->request->data('userId')])->first();
			$check = (new DefaultPasswordHasher)->check($this->request->data('oldPassword'), $users->password);
			if($check){
				$users = $this->Users->patchEntity($users, ['password'=> $this->request->data('newPassword'),'Pcode' => base64_encode($this->request->data['newPassword'])],['validate' => false]);
				$this->Users->save($users);
				$response['status'] = 'success';
				$response['msg'] = 'Password update successfully.';
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'Current password does not match.';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'UserId is required.';
		}
		return  $response;
	}
	
	function forgotpassword(){
		$this->loadModel('Users');
		if($this->request->data('email')){
			$users = $this->Users->find()->Where(['Users.email' => $this->request->data('email')])->first();
			$OLDPASS = base64_decode(@$users->Pcode);
			//$check = (new DefaultPasswordHasher)->check($this->request->data('oldPassword'), $users->password);
			if($users){
				$newPasss = rand(1111111,99999999);
				$users = $this->Users->patchEntity($users, ['password'=> $newPasss],['validate' => false]);
				$this->Users->save($users);
				$to = $users->email;
				//$to = 'raushan.kumar@evirtualservices.com';
				$subject = 'Labor Dispatch-Reset Password '.$to;
				$message="Dear ".ucfirst($users->fullName);
				$message.="<br><br> You have request for the reset password. Your new credentials is given below:";
				$message.='<br>Name: '.ucfirst($users->fullName);
				$message.='<br>Email: '.$this->request->data['email'].'<br>Password: '.$newPasss;
				$this->phpemail($to,$subject,$message);
				//echo mail('rksuri2@gmail.com', 'HI', 'HELLO'); die('+++');
				$response['status'] = 'success';
				$response['email'] = $users->email;
				$response['newpassword'] = $newPasss;
				$response['oldpassword'] = $OLDPASS;
				$response['msg'] = 'Password sent to the registered email.';
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'Email does not exist with Labor Dispatch.';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'email is required.';
		}
		return  $response;
	}
	
	
	
	function disclosures(){
		$this->loadModel('Pages');
		
		$pages = $this->Pages->find()->Where(['Pages.id' => 7])->first();
		$response['status'] = 'success';
		$response['msg'] = $pages->content;
		return  $response;
	}
	
	function termAndConditions(){
		$this->loadModel('Pages');
		
		$pages = $this->Pages->find()->Where(['Pages.id' => 5])->first();
		$response['status'] = 'success';
		$response['msg'] = $pages->content;
		return  $response;
	}
	function privacypolicy(){
		$this->loadModel('Pages');
		$pages = $this->Pages->find()->Where(['Pages.id' => 4])->first();
		$response['status'] = 'success';
		$response['msg'] = $pages->content;
		return  $response;
	}
	
				function statelist(){
						$this->loadModel('States');
						$parentCountryList = $this->States->find()
																								->where(['States.country_id'=>231, 'States.status'=>1])
                        ->order(['States.name'=>'ASC'])->toArray();
						$PC = array();
						foreach($parentCountryList as $key=>$VV){
							$PC['id'] 							= $VV->id;
							$PC['name'] 					= ($VV->name) ? $VV->name : '';
							$PC['stateCode'] = ($VV->stateCode)? $VV->stateCode :'';
							$list[] = $PC;
						}
						$response['status'] = "success";
						$response['data'] = $list;
						return $response;
				}
				
				function capabilities(){
						$this->loadModel('Capabilities');
						$parentCountryList = $this->Capabilities->find()
																								->where(['Capabilities.status'=>1])
                        ->order(['Capabilities.name'=>'ASC'])->toArray();
						$PC = array();
						foreach($parentCountryList as $key=>$VV){
							$PC['id'] 							= $VV->id;
							$PC['name'] 					= ($VV->name) ? $VV->name : '';
							$list[] = $PC;
						}
						$response['status'] = "success";
						$response['data'] = ($list) ? $list : array();
						return $response;
				}
				
				
				
				
			function category(){
					$this->loadModel('Categories');
					$conditons = array('Categories.status' => '1' , 'Categories.parentId' => 0);
					if(isset($this->request->data['keyword']) && $this->request->data['keyword'] !=''){
						$conditons = array('Categories.name LIKE' =>'%'.$this->request->data['keyword'].'%','Categories.status' => '1' , 'Categories.parentId' => 0);
					}
					$cat=$this->Categories->find('all')->where($conditons)->select(['Categories.id','Categories.name','Categories.image','Categories.bigImage'])->toArray();
					$gautam=array();
					$i=0;
					//$cat=$this->array_filter_recursive($cat);
					foreach($cat as $v){
						$gautam[$i]['id'] 				=  $v->id;
						$gautam[$i]['name'] 		= $v->name;
						$gautam[$i]['image'] 	= ($v->image) ? $this->catPath.$v->image : '';
						$sub = $this->Categories->find('all')->where(["Categories.parentId" => $v->id, 'Categories.status' => '1'])->select(['Categories.id','Categories.name','Categories.image','Categories.bigImage'])->toArray();
						//$gautam[$i]["SubCat"] = $sub;
						$subb = array();
						foreach($sub as $keyy=>$vc){
							$subb[$keyy]['id'] 					= $vc->id;
							$subb[$keyy]['name'] 			= $vc->name;
							$subb[$keyy]['image'] 		= ($vc->image) ? $this->catPath.$vc->image : '';
						}
						$gautam[$i]["SubCat"] = ($subb) ? $subb : array();
						$i++; 
					}
					$response['status'] = "success";
					$response['data'] = ($gautam) ? $this->array_filter_recursive($gautam) : array();
					return $response; 
			}
			
		
			
			function cashoutrequest(){
						$this->loadModel('Users');
						$this->loadModel('Cashoutrequests');
							if($this->request->data['userId'] !='' && $this->request->data['requestAmount'] !=''){
								
									$users = $this->Cashoutrequests->newEntity();
									$users = $this->Cashoutrequests->patchEntity($users, $this->request->data, ['validate' => false]);
									$users['created'] 	= date('Y-m-d H:i:s');
									$users['status'] 	= '1';
									if ($this->Cashoutrequests->save($users)) {
													$response['status'] = 'success';
													$response['msg'] = 'Cashout request sent successfully.';
									}
							}else{
								$response['status'] = 'Fails';
								$response['msg'] = 'userId and amount are required.';
							}
							return  $response;
			}
			
			function cashoutlist($user_id=NULL){
								$this->loadModel('Users');
								$this->loadModel('Cashoutrequests');
								$userId = ($user_id) ? $user_id : $this->request->data('userId');
								$pageNo = ($this->request->data('pageNo')) ? $this->request->data('pageNo') : '1';
								if($userId !=''){
										$this->paginate = [
																'limit' => '10',//$limit,
																'order' => ['Cashoutrequests.id' => 'desc'],
																'page'=>$pageNo,
																//'contain'=>['Resturents','Categories']
													];
													$condition[] = '';
														if($userId != ''){
																$condition[] = ['Cashoutrequests.userId' => $userId];
														}
														$userservices =array();    
														$query = $this->Cashoutrequests->find('all')->where($condition);
														$totalCount =  $query->count();
														if($pageNo <= ceil($totalCount/10)){
																$userservices = $this->paginate($query);
																$userservices = $userservices->toArray();
														}
														$CATArray = array();
														$Darray = array();
														$i=0;
														//echo "<pre>"; print_r($userservices); die;
														foreach($userservices as $userD){
																$Darray[$i]['requestId']     = ($userD->id) ? $userD->id : '';
																$Darray[$i]['requestAmount'] = ($userD->requestAmount) ? $userD->requestAmount : '';
																$Darray[$i]['sendAmount'] 			= ($userD->sendAmount) ? $userD->sendAmount : '';
																$Darray[$i]['sendDate'] 					= ($userD->sendDate) ? date('Y-m-d H:i:s', strtotime($userD->sendDate)) : '';
																
																$Darray[$i]['created'] 						= ($userD->created) ? date('Y-m-d H:i:s', strtotime($userD->created)) : '';
																$i++;
														}
												$response['status'] = 'success';
												$response['data'] = array_values($this->array_filter_recursive($Darray));
												
								}else{
										$response['status'] = 'Fails';
										$response['msg'] = 'UserId is required';
								}
								return $response;
			}
	
			function updatepayment(){
					if($this->request->data['userId'] !='' && $this->request->data['groupId'] !='' ){
						$this->loadModel('Bookings');
						$this->loadModel('Bookingrequests');
						$articles = TableRegistry::get('Bookings');
						$query = $articles->query();
						$query->update()
						->set(['totalAmount' =>$this->request->data['totalAmount'],'transactionId'=>@$this->request->data['transactionId'], 'serviceType'=>@$this->request->data['serviceType'],'couponCode'=>@$this->request->data['couponCode'],'discountAmount'=>@$this->request->data['discountAmount'],'TIP'=>@$this->request->data['TIP'],'serviceAmount'=>@$this->request->data['serviceAmount']])
						->where(['groupId' => $this->request->data['groupId']])
						->execute();
						
							$bookings = $this->Bookings->find()->where(['Bookings.groupId'=>$this->request->data['groupId']])->contain(['Users','Categories'])->first();
							//pr($bookings); die;
							//$to='raushan.kumar@evirtualservices.com';
								$to= @$bookings->user->email;
								$subject="Labor Dispatch Booking #".$this->request->data['groupId'];
								$message="Dear ".ucfirst(@$bookings->user->fullName);
								$message .= '<br>Thank you for booking.<br><br>Your booking has been confirm <strong>#'.$this->request->data['groupId'].'</strong>';
								$message .= '<br>You have booked the <strong>'.@$bookings->category->name.'</strong> service';
								$message .='<br>and your package is <strong>'.$bookings->serviceType.'</strong>'	;
								if($to){
									$this->phpemail($to, $subject, $message);
								}
								
								$articles = TableRegistry::get('Bookingrequests');
								$query = $articles->query();
								$query->update()
								->set(['status' =>1])
								->where(['bookingId' => $bookings->id])
								->execute();
						
								//$Bookingrequests = $this->Bookingrequests->find()->where(['Bookingrequests.bookingId'=>$bookings->id])->contain(['Users'])->toArray();
								//foreach($Bookingrequests as $vvv){
								//		$bodyU['message'] = 'New booking request to confirm or decline.';
								//		if(strtolower(@$vvv->user->device) =='ios'){
								//			$this->sednIosPushNotification(@$vvv->user->deviceToken,$bodyU);
								//		}else{
								//			$this->sendNotificationOnAndroid(@$vvv->user->deviceToken,$bodyU);
								//		}
								//}
													
								$bodyU['message'] = ucfirst(@$bookings->category->name).' service has been booked successfully.';
								if(strtolower($bookings->user->device) =='ios'){
									$this->sednIosPushNotification($bookings->user->deviceToken,$bodyU);
								}else{
									$this->sendNotificationOnAndroid($bookings->user->deviceToken,$bodyU);
								}
										
						//$bookings = $this->Bookings->find()->where(['Bookings.id'=>$this->request->data['bookingId'], 'Bookings.userId'=>$this->request->data['userId']])->first();
						//$bookings = $this->Bookings->patchEntity($bookings, $INVO, ['validate' => false]);
						//$Booking['status'] 		= '0';
						//$this->Bookings->save($Booking);
						
							$response['status'] = "success";
							$response['msg'] = 'Booking payment successfully.';
					}else{
						$response['status'] = 'Fail';
						$response['msg'] = 'userId and groupId are required';	
					}
					return $response; 
			}
			
			
			
			function findvendor(){
				$this->loadModel('Users');
				if($this->request->data('userId') !='' && $this->request->data('latitude') !='' && $this->request->data('longitude') !=''){
				$latitude 	= $this->request->data['latitude']; 
				$longitude	= $this->request->data['longitude'];
				
				$conn = ConnectionManager::get('default');
				$radius = "( 3959 * acos( cos( radians($latitude) ) * cos( radians(latitude) ) * cos( radians(longitude) - radians($longitude))  + sin(radians($latitude ))	* sin( radians(latitude))))";
				$query = "SELECT id, address, fullName, profile_picture,contactNumber, $radius AS distance FROM users WHERE `role`='Driver' HAVING distance < 5000 ORDER BY distance LIMIT 0 , 2000";
			
				$stmt = $conn->execute($query);
				$results = $stmt ->fetchAll('assoc');
				//echo "<pre>"; print_r($results); die;
					$i = 0;
					$array = array();
					foreach($results as $val){
						$array[$i]['id'] = $val['id'];
						$array[$i]['fullName'] = ($val['fullName']) ? $val['fullName'] : '';
						$array[$i]['address'] = ($val['address']) ? $val['address'] : '';
						$array[$i]['contactNumber'] = ($val['contactNumber']) ? $val['contactNumber'] : '';
						$array[$i]['profile_picture'] = ($val['profile_picture']) ? $this->profilePath.$val['profile_picture'] : '';
						$i++;
					}
					$response['status'] = "success";
					$response['data'] = ($array) ? $this->array_filter_recursive($array) : array();
				}else{
					$response['status'] = 'Fail';
					$response['msg'] = 'vendorId, startTime, endTime, brakeStartTime, breakEndTime, and dayarray are required';	
				}
				
				return $response; 
			}
			
			
			function addbooking(){
						$this->loadModel('Bookings');
						$this->loadModel('Users');
						$this->loadModel('Bookingrequests');
						if($this->request->data['userId'] !='' && $this->request->data['bookingDate'] !='' && $this->request->data['latitude'] !='' && $this->request->data['longitude'] !=''){
							
							$usersD = $this->Users->find()->where(['Users.id'=>$this->request->data['userId']])->first();
								$latitude 	= $this->request->data['latitude']; 
								$longitude	= $this->request->data['longitude'];
									
								$conn = ConnectionManager::get('default');
								$radius = "( 3959 * acos( cos( radians($latitude) ) * cos( radians(latitude) ) * cos( radians(longitude) - radians($longitude))  + sin(radians($latitude ))	* sin( radians(latitude))))";
								$query = "SELECT id, address, fullName, profile_picture,device,deviceToken,contactNumber, $radius AS distance FROM users WHERE `role`='Member' HAVING distance < 50000 ORDER BY distance LIMIT 0 , 100";
								$stmt = $conn->execute($query);
								$results = $stmt ->fetchAll('assoc');
								
								$tastOrderId = $this->Bookings->find()->order(['Bookings.groupId'=>'desc'])->first();
								$groupID = 1;
								if(@$tastOrderId->groupId !=''){
									$groupID = (@$tastOrderId->groupId) + 1;
								}
									if($results){
													if(@$this->request->data['service']){
														$this->request->data['Title'] = @$this->request->data['service'];
													}
													$Booking = $this->Bookings->newEntity();
													$Booking = $this->Bookings->patchEntity($Booking, $this->request->data, ['validate' => false]);
													$Booking['bookingDate'] 	= date('Y-m-d',strtotime($this->request->data['bookingDate']));
													$Booking['created'] 					= date('Y-m-d H:i:s');
													$Booking['status'] 						= '0';
													$this->Bookings->save($Booking);
													
											foreach($results as $val){
													$Request = $this->Bookingrequests->newEntity();
													$INVO['bookingId'] 						= @$Booking->id;
													$INVO['driverId']								= $val['id'];
													$Request = $this->Bookingrequests->patchEntity($Request, $INVO, ['validate' => false]);
													$Request['created'] 					= date('Y-m-d H:i:s');
													$Request['status'] 						= '1';
													$this->Bookingrequests->save($Request);
													
													$bodyU['message'] = 'New booking request to confirm or decline.';
													$bodyU['type'] = 'acceptJob';
													$bodyU['Title'] = @$Booking->Title;
													$bodyU['HourlyRate'] = @$Booking->HourlyRate;
													$bodyU['FlatRate'] = @$Booking->FlatRate;
													$bodyU['bookingDate'] = date('Y-m-d',strtotime(@$Booking->bookingDate));
													$bodyU['address'] = @$Booking->address;
													$bodyU['weight'] = @$Booking->weight;
													$bodyU['message'] = @$Booking->message;
													$bodyU['bookingId'] = @$Booking->id;
													$bodyU['slote'] = @$Booking->slote;
													$bodyU['DriverName'] = @$usersD->fullName;
													if(strtolower($val['device']) =='ios'){
														$this->sednIosPushNotification($val['deviceToken'],$bodyU);
													}else{
														$this->sendNotificationOnAndroid($val['deviceToken'],$bodyU);
													}
											}
												$response['status'] = 'success';
												$response['bookingGroupId'] = $groupID;
												$response['bookingId'] = @$Booking->id;
												$response['msg'] = 'Booking completed succssfully';
									}else{
										$response['status'] = 'Fail';
										$response['msg'] = 'Driver not found for this service within 50000 mile';
									}
										
						}else{
								$response['status'] = 'Fail';
								$response['msg'] = 'userId, bookingdate, latitude and longitude are required';	
						}
						return 	$response;
			}
	
	function requestbookinglist($user_id=NULL, $userType=NULL,$status=NULL){
		$this->loadModel('Bookingrequests');
		
			$userId = ($user_id) ? $user_id : $this->request->data('userId');
			$STATUS = ($status) ? $status : $this->request->data('status');
			$usertype = ($userType) ? $userType : $this->request->data('userType');
		
		if($userId){
			
				$pageNo = ($this->request->data('pageNo')) ? $this->request->data('pageNo') : '1';
				
					$this->paginate = [
											'limit' => '10',//$limit,
											'order' => ['Bookingrequests.id' => 'desc'	],
											'page'=>$pageNo,
											'contain'=>['Bookings'=>['Categories','Users','Vendors']]
									];
					
								
										$condition[] = ['Bookingrequests.driverId	' => $userId];
									//echo "<pre>"; print_r($condition); die;
									$userservices =array();    
									$query = $this->Bookingrequests->find('all')->where($condition);
									$totalCount =  $query->count();
									if($pageNo <= ceil($totalCount/10)){
											$userservices = $this->paginate($query);
											$userservices = $userservices->toArray();
									}
									$Darray = array();
									$i=0;
									//echo "<pre>"; print_r($userservices); die;
									foreach($userservices as $userD){
											$Darray[$i]['bookingId'] 								= (@$userD->booking->id) ? @$userD->booking->id : '';
											$Darray[$i]['groupId'] 										= (@$userD->booking->groupId) ? @$userD->booking->groupId : '';
											$Darray[$i]['bookingDate'] 						= (@$userD->booking->bookingDate) ? date("jS M", strtotime(@$userD->booking->bookingDate)) : '';
											$Darray[$i]['address'] 										= (@$userD->booking->address) ? @$userD->booking->address : '';
											$Darray[$i]['Title'] 												= (@$userD->booking->Title) ? @$userD->booking->Title : '';
											
											$Darray[$i]['weight'] 											= (@$userD->booking->weight) ? @$userD->booking->weight : '';
											$Darray[$i]['message'] 										= (@$userD->booking->message) ? @$userD->booking->message : '';
											$Darray[$i]['HourlyRate'] 							= (@$userD->booking->HourlyRate) ? @$userD->booking->HourlyRate : '';
											$Darray[$i]['FlatRate'] 									= (@$userD->booking->FlatRate) ? @$userD->booking->FlatRate : '';
											
											$Darray[$i]['totalAmount'] 						= (@$userD->booking->totalAmount) ? strval(@$userD->booking->totalAmount) : "0";
											$Darray[$i]['TIP'] 														= (@$userD->booking->TIP) ? strval(@$userD->booking->TIP) : "0";
											
											if($usertype == 'Member'){
													$Darray[$i]['userId'] 								= (@$userD->booking->vendor->id) ? @$userD->booking->vendor->id : '';
													$Darray[$i]['fullName'] 						= (@$userD->booking->vendor->fullName) ? @$userD->booking->vendor->fullName : '';
													$Darray[$i]['email'] 									= (@$userD->booking->vendor->email) ? @$userD->booking->vendor->email : '';
													$Darray[$i]['zipCode'] 							= (@$userD->booking->vendor->zipCode) ? @$userD->booking->vendor->zipCode : '';
													$Darray[$i]['contactNumber'] 	= (@$userD->booking->vendor->contactNumber) ? @$userD->booking->vendor->contactNumber :'';
													$Darray[$i]['userAddress']				= (@$userD->booking->vendor->address) ? @$userD->booking->vendor->address : '';
													$Darray[$i]['AVGRating']						= (@$userD->booking->vendor->AVGRating) ? @$userD->booking->vendor->AVGRating : '';
													$Darray[$i]['image'] 									= (@$userD->booking->vendor->profile_picture) ? $this->profilePath.@$userD->booking->vendor->profile_picture : '';
											}else{
													$Darray[$i]['userId'] 								= (@$userD->booking->user->id) ? @$userD->booking->user->id : '';
													$Darray[$i]['fullName'] 						= (@$userD->booking->user->fullName) ? @$userD->booking->user->fullName : '';
													$Darray[$i]['email'] 									= (@$userD->booking->user->email) ? @$userD->booking->user->email : '';
													$Darray[$i]['zipCode'] 							= (@$userD->booking->user->zipCode) ? @$userD->booking->user->zipCode : '';
													$Darray[$i]['contactNumber'] 	= (@$userD->booking->user->contactNumber) ? @$userD->booking->user->contactNumber :'';
													$Darray[$i]['userAddress']				= (@$userD->booking->user->address) ? @$userD->booking->user->address : '';
													$Darray[$i]['AVGRating']						= (@$userD->booking->user->AVGRating) ? @$userD->booking->user->AVGRating : '';
													$Darray[$i]['image'] 									= (@$userD->booking->user->profile_picture) ? $this->profilePath.@$userD->booking->user->profile_picture : '';
											}
											$Darray[$i]['status'] 							= (@$userD->booking->status) ? @$userD->booking->status : 0;
											$Darray[$i]['categoryName'] 		= (@$userD->booking->ctegory->name) ? @$userD->booking->ctegory->name : '';
											
											
											$Darray[$i]['created'] 						= (@$userD->booking->created) ? date('Y-m-d H:i:s', strtotime(@$userD->booking->created)) : '';
											$i++;
									}
					$response['status'] = 'success';
					$response['data'] = array_values($this->array_filter_recursive($Darray));
			
		}else{
			$response['status'] = "Fail";	
			$response['msg'] = "userId required";	
		}
		return $response;
	}
	
	/*this is for booking not for job*/
	function bookinglist($user_id=NULL, $userType=NULL,$status=NULL){
		$this->loadModel('Bookings');
		
			$userId = ($user_id) ? $user_id : @$this->request->data('userId');
			$STATUS = ($status) ? $status : @$this->request->data('status');
			$usertype = ($userType) ? $userType : @$this->request->data('userType');
		
		if($userId){
			
				$pageNo = ($this->request->data('pageNo')) ? $this->request->data('pageNo') : '1';
				
					$this->paginate = [
											'limit' => '10',//$limit,
											'order' => ['Bookings.id' => 'desc'],
											'page'=>$pageNo,
											'contain'=>['Users','Vendors', 'Categories']
									];
								$condition[] = '';
									if($usertype == 'Member'){
											$condition[] = ['Bookings.vendorId' => $userId];
									}else if($usertype == 'Driver'){
											$condition[] = ['Bookings.userId' => $userId];
									}
									//$condition[] = ['Bookings.bookingDate' => date('Y-m-d')];
									if($STATUS != ''){
											$condition[] = ['Bookings.status' => $STATUS];
									}
									//echo "<pre>"; print_r($condition); die;
									$userservices =array();    
									$query = $this->Bookings->find('all')->where($condition);
									$totalCount =  $query->count();
									if($pageNo <= ceil($totalCount/10)){
											$userservices = $this->paginate($query);
											$userservices = $userservices->toArray();
									}
									$Darray = array();
									$i=0;
									//echo "<pre>"; print_r($userservices); die;
									foreach($userservices as $userD){
											$Darray[$i]['bookingId'] 								= ($userD->id) ? $userD->id : '';
											$Darray[$i]['groupId'] 										= ($userD->groupId) ? $userD->groupId : '';
											$Darray[$i]['bookingDate'] 						= ($userD->bookingDate) ? date("jS M", strtotime($userD->bookingDate)) : '';
											$Darray[$i]['address'] 										= ($userD->address) ? $userD->address : '';
											$Darray[$i]['slote'] 												= ($userD->slote) ? $userD->slote : '';
											$Darray[$i]['HourlyRate'] 							= ($userD->HourlyRate) ? "$userD->HourlyRate" : "0";
											$Darray[$i]['FlatRate'] 									= ($userD->FlatRate) ? "$userD->FlatRate" : "0";
											$Darray[$i]['weight'] 											= ($userD->weight) ? $userD->weight : '';
											$Darray[$i]['message'] 										= ($userD->message) ? $userD->message : '';
											$Darray[$i]['Title'] 												= ($userD->Title) ? $userD->Title : '';
											$Darray[$i]['latitude'] 									= ($userD->latitude) ? $userD->latitude : '';
											$Darray[$i]['longitude'] 								= ($userD->longitude) ? $userD->longitude : '';
											
											if($usertype == 'Member'){
													$Darray[$i]['userId'] 								= (@$userD->vendor->id) ? @$userD->vendor->id : '';
													$Darray[$i]['fullName'] 						= (@$userD->vendor->fullName) ? @$userD->vendor->fullName : '';
													$Darray[$i]['email'] 									= (@$userD->vendor->email) ? @$userD->vendor->email : '';
													$Darray[$i]['zipCode'] 							= (@$userD->vendor->zipCode) ? @$userD->vendor->zipCode : '';
													$Darray[$i]['contactNumber'] 	= (@$userD->vendor->contactNumber) ? @$userD->vendor->contactNumber :'';
													$Darray[$i]['userAddress']				= (@$userD->vendor->address) ? @$userD->vendor->address : '';
													$Darray[$i]['AVGRating']						= (@$userD->vendor->AVGRating) ? @$userD->vendor->AVGRating : '';
													$Darray[$i]['image'] 									= (@$userD->vendor->profile_picture) ? $this->profilePath.@$userD->vendor->profile_picture : '';
											}else{
													$Darray[$i]['userId'] 								= (@$userD->user->id) ? @$userD->user->id : '';
													$Darray[$i]['fullName'] 						= (@$userD->user->fullName) ? @$userD->user->fullName : '';
													$Darray[$i]['email'] 									= (@$userD->user->email) ? @$userD->user->email : '';
													$Darray[$i]['zipCode'] 							= (@$userD->user->zipCode) ? @$userD->user->zipCode : '';
													$Darray[$i]['contactNumber'] 	= (@$userD->user->contactNumber) ? @$userD->user->contactNumber :'';
													$Darray[$i]['userAddress']				= (@$userD->user->address) ? @$userD->user->address : '';
													$Darray[$i]['AVGRating']						= (@$userD->user->AVGRating) ? @$userD->user->AVGRating : '';
													$Darray[$i]['image'] 									= (@$userD->user->profile_picture) ? $this->profilePath.@$userD->user->profile_picture : '';
											}
											$Darray[$i]['status'] 							= ($userD->status) ? $userD->status : 0;
											$Darray[$i]['categoryName'] 		= (@$userD->category->name) ? @$userD->category->name : '';
											
											$Darray[$i]['created'] 						= ($userD->created) ? date('Y-m-d H:i:s', strtotime($userD->created)) : '';
											$i++;
									}
					$response['status'] = 'success';
					$response['data'] = array_values($this->array_filter_recursive($Darray));
			
		}else{
			$response['status'] = "Fail";	
			$response['msg'] = "userId required";	
		}
		return $response;
	}
	
	function upcomingbookinglist($user_id=NULL, $userType=NULL,$status=NULL){
		$this->loadModel('Bookings');
		
			$userId = ($user_id) ? $user_id : @$this->request->data('userId');
			$STATUS = ($status) ? $status : @$this->request->data('status');
			$usertype = ($userType) ? $userType : @$this->request->data('userType');
		
		if($userId){
			
				$pageNo = ($this->request->data('pageNo')) ? $this->request->data('pageNo') : '1';
				
					$this->paginate = [
											'limit' => '10',//$limit,
											'order' => ['Bookings.id' => 'desc'],
											'page'=>$pageNo,
											'contain'=>['Users','Vendors', 'Categories']
									];
								$condition[] = ['Bookings.bookingDate >'=>date('Y-m-d')];
									if($usertype == 'Member'){
											$condition[] = ['Bookings.vendorId' => $userId];
									}else if($usertype == 'Driver'){
											$condition[] = ['Bookings.userId' => $userId];
									}
									//$condition[] = ['Bookings.bookingDate' => date('Y-m-d')];
									if($STATUS != ''){
											$condition[] = ['Bookings.status' => $STATUS];
									}
									//echo "<pre>"; print_r($condition); die;
									$userservices =array();    
									$query = $this->Bookings->find('all')->where($condition);
									$totalCount =  $query->count();
									if($pageNo <= ceil($totalCount/10)){
											$userservices = $this->paginate($query);
											$userservices = $userservices->toArray();
									}
									$Darray = array();
									$i=0;
									//echo "<pre>"; print_r($userservices); die;
									foreach($userservices as $userD){
											$Darray[$i]['bookingId'] 								= ($userD->id) ? $userD->id : '';
											$Darray[$i]['groupId'] 										= ($userD->groupId) ? $userD->groupId : '';
											$Darray[$i]['bookingDate'] 						= ($userD->bookingDate) ? date("jS M", strtotime($userD->bookingDate)) : '';
											$Darray[$i]['address'] 										= ($userD->address) ? $userD->address : '';
											$Darray[$i]['slote'] 												= ($userD->slote) ? $userD->slote : '';
											$Darray[$i]['HourlyRate'] 							= ($userD->HourlyRate) ? "$userD->HourlyRate" : "0";
											$Darray[$i]['FlatRate'] 									= ($userD->FlatRate) ? "$userD->FlatRate" : "0";
											$Darray[$i]['weight'] 											= ($userD->weight) ? $userD->weight : '';
											$Darray[$i]['message'] 										= ($userD->message) ? $userD->message : '';
											$Darray[$i]['Title'] 												= ($userD->Title) ? $userD->Title : '';
											$Darray[$i]['latitude'] 									= ($userD->latitude) ? $userD->latitude : '';
											$Darray[$i]['longitude'] 								= ($userD->longitude) ? $userD->longitude : '';
											
											if($usertype == 'Member'){
													$Darray[$i]['userId'] 								= (@$userD->vendor->id) ? @$userD->vendor->id : '';
													$Darray[$i]['fullName'] 						= (@$userD->vendor->fullName) ? @$userD->vendor->fullName : '';
													$Darray[$i]['email'] 									= (@$userD->vendor->email) ? @$userD->vendor->email : '';
													$Darray[$i]['zipCode'] 							= (@$userD->vendor->zipCode) ? @$userD->vendor->zipCode : '';
													$Darray[$i]['contactNumber'] 	= (@$userD->vendor->contactNumber) ? @$userD->vendor->contactNumber :'';
													$Darray[$i]['userAddress']				= (@$userD->vendor->address) ? @$userD->vendor->address : '';
													$Darray[$i]['AVGRating']						= (@$userD->vendor->AVGRating) ? @$userD->vendor->AVGRating : '';
													$Darray[$i]['image'] 									= (@$userD->vendor->profile_picture) ? $this->profilePath.@$userD->vendor->profile_picture : '';
											}else{
													$Darray[$i]['userId'] 								= (@$userD->user->id) ? @$userD->user->id : '';
													$Darray[$i]['fullName'] 						= (@$userD->user->fullName) ? @$userD->user->fullName : '';
													$Darray[$i]['email'] 									= (@$userD->user->email) ? @$userD->user->email : '';
													$Darray[$i]['zipCode'] 							= (@$userD->user->zipCode) ? @$userD->user->zipCode : '';
													$Darray[$i]['contactNumber'] 	= (@$userD->user->contactNumber) ? @$userD->user->contactNumber :'';
													$Darray[$i]['userAddress']				= (@$userD->user->address) ? @$userD->user->address : '';
													$Darray[$i]['AVGRating']						= (@$userD->user->AVGRating) ? @$userD->user->AVGRating : '';
													$Darray[$i]['image'] 									= (@$userD->user->profile_picture) ? $this->profilePath.@$userD->user->profile_picture : '';
											}
											$Darray[$i]['status'] 							= ($userD->status) ? $userD->status : 0;
											$Darray[$i]['categoryName'] 		= (@$userD->category->name) ? @$userD->category->name : '';
											
											$Darray[$i]['created'] 						= ($userD->created) ? date('Y-m-d H:i:s', strtotime($userD->created)) : '';
											$i++;
									}
					$response['status'] = 'success';
					$response['data'] = array_values($this->array_filter_recursive($Darray));
			
		}else{
			$response['status'] = "Fail";	
			$response['msg'] = "userId required";	
		}
		return $response;
	}
	
	
	function getearning($user_id=NULL, $userType=NULL,$status=NULL,$dateBy=NULL){
		$this->loadModel('Bookings');
		
			$userId = ($user_id) ? $user_id : $this->request->data('userId');
			$STATUS = ($status) ? $status : $this->request->data('status');
			$usertype = ($userType) ? $userType : $this->request->data('usertype');
			$dateBY = ($dateBy) ? $dateBy : $this->request->data('dateBy');
		
		if($userId){
			
				$pageNo = ($this->request->data('pageNo')) ? $this->request->data('pageNo') : '1';
				
					$this->paginate = [
											'limit' => '1000',//$limit,
											'order' => [
													'Bookings.id' => 'desc'
												],
											'page'=>$pageNo,
											'contain'=>['Users','Vendors', 'Categories']
									];
									
									if($dateBY !=''){
										if($dateBY == 'Today'){
											$DATES = date('Y-m-d'). ' 00:00:01';
											$DATEE = date('Y-m-d'). ' 23:59:59';
											$condition[] = ['Bookings.created >=' => $DATES, 'Bookings.created <=' => $DATEE];
										}elseif($dateBY == 'Weekly'){
											$DATES = date("Y-m-d", strtotime("-7 days")). ' 00:00:01';
											$DATEE = date("Y-m-d"). ' 23:59:59';
											$condition[] = ['Bookings.created >=' => $DATES, 'Bookings.created <=' => $DATEE];
										}
									}
									
									$condition[] = ['Bookings.vendorId' => $userId];
									$condition[] = ['Bookings.status' => 2];
									$userservices =array();
									$TOTALAM = 0;
									$query = $this->Bookings->find('all')->where($condition)->select('totalAmount','SUM(totalAmount) AS amount');
									$totalCount =  $query->count();
									if($pageNo <= ceil($totalCount/10)){
											$userservices = $this->paginate($query);
											$userservices = $userservices->toArray();
									}
									$Darray = array();
									$i=0;
									//echo "<pre>"; print_r($userservices); die;
									foreach($userservices as $userD){
											$TOTALAM += $userD->totalAmount;
											$i++;
									}
					$response['status'] = 'success';
					$response['totalCount'] = $totalCount;
					$response['totalAmount'] = $TOTALAM;
			
		}else{
			$response['status'] = "Fail";	
			$response['msg'] = "userId required";	
		}
		return $response;
	}
	
	
	function changebookingstatus(){
		$this->loadModel('Purchases');
		if(@$this->request->data['purcheseId'] !='' && @$this->request->data['status'] !='' && @$this->request->data['driverId'] !=''){
				$purcheses = $this->Purchases->find()->where(['Purchases.id' => $this->request->data['purcheseId']])->first();
				if(!empty($purcheses)){
					//$this->request->data['message'];
							if($purcheses->status == 1){
										$articles = TableRegistry::get('Purchases');
										$query = $articles->query();
										$query->update()
										->set(['status' =>$this->request->data['status']])
										->where(['id' => $purcheses->id])
										->execute();
										$response['status'] = 'success';
										$response['msg'] = 'Order status updated successfully.';
							}else{
									$response['status'] = 'Fails';
									$response['msg'] = 'Order already close or delivered by someone\'s else';
								
							}
				}else{
					$response['status'] = "Fail";	
					$response['msg'] = "userId required";	
				}
		
		}else{
			$response['status'] = "Fail";	
			$response['msg'] = "userId required";	
		}
		return $response;
	}
	
			private function changestatus(){
					$this->loadModel('Bookings');
					$this->loadModel('Users');
					$this->loadModel('Bookingrequests');
					if($this->request->data['bookingId'] !='' && $this->request->data['status'] !='' && $this->request->data['userId'] !=''){
						$this->loadModel('Users');
						$bookings = $this->Bookings->find()->where(['Bookings.id' => $this->request->data['bookingId']])->contain(['Users'])->first();
						if(!empty($bookings)){
							//pr($bookings); //die;
							if($this->request->data['status'] == 1){
								if($bookings->status == 0){
										$articles = TableRegistry::get('Bookings');
										$query = $articles->query();
										$query->update()
										->set(['vendorId'=>$this->request->data['userId'],'status' =>1])
										->where(['id' => $this->request->data['bookingId']])
										->execute();
										$this->Bookingrequests->deleteAll(['Bookingrequests.bookingId'=>$this->request->data['bookingId']]);
								}else{
										$response['status'] = 'Fails';
										$response['msg'] = 'Booking already close or accepted by someone\'s else';
										return  $response;
								}
							}elseif($this->request->data['status'] == 2){
										$articles = TableRegistry::get('Bookings');
										$query = $articles->query();
										$query->update()
										->set(['status' =>2])
										->where(['id' => $this->request->data['bookingId']])
										->execute();
										
										$driver = $this->Users->find()->where(['Users.id'=>$this->request->data['userId']])->first();
										$articles2 = TableRegistry::get('Users');
												$query2 = $articles2->query();
												$query2->update()
													->set(['wallet' =>($driver->wallet + $bookings->totalAmount)])
													->where(['id' => $driver->id])
													->execute();
													
										$response['msg'] = 'Booking completed succssfully.';
							}elseif($this->request->data['status'] == 3){
								$da = $this->Bookingrequests->find()->where(['Bookingrequests.bookingId'=>$this->request->data['bookingId'],'Bookingrequests.driverId'=>$this->request->data['userId'] ])->first();
								@$this->Bookingrequests->delete($da);
								$response['msg'] = 'Booking declined';
							}
								$response['status'] = 'success';
								if($this->request->data['status'] == 1){
									$users = $this->Users->find()->where(['Users.id'=>$this->request->data['userId']])->first();
										$response['msg'] = 'Booking accepted successfully.';
										$bodyU['message'] = @$users->fullName.' has been accepted your booking successfully.';
										$bodyU['type'] 			= 'helper';
										$bodyU['name'] 			= $users->fullName;
										$bodyU['image'] 		= $this->profilePath.$users->profile_picture;
										$bodyU['date'] 			= ($bookings->bookingDate) ? date("jS M", strtotime($bookings->bookingDate)) : '';
										$bodyU['slote'] 		= ($bookings->slote) ? $bookings->slote : '';
										$bodyU['jobMessage'] = ($bookings->message) ? $bookings->message : '';
										$bodyU['Title'] 		= ($bookings->Title) ? $bookings->Title : '';
										$bodyU['address'] = $users->address;
										$bodyU['email'] 		= $users->email;
										$bodyU['phone'] 		= $users->contactNumber;
										$bodyV['message'] = 'Booking accepted successfully.';
										$bodyV['bookingId'] = $bookings->id;
										if(strtolower(@$bookings->user->device) =='ios'){
											$this->sednIosPushNotification(@$bookings->user->deviceToken,$bodyU);
										}else{
											$this->sendNotificationOnAndroid(@$bookings->user->deviceToken,$bodyU);
											//echo $bookings->user->deviceToken; 
										}
										
										if(strtolower(@$bookings->vendor->device) =='ios'){
											$this->sednIosPushNotification(@$bookings->vendor->deviceToken,$bodyV);
										}else{
											$this->sendNotificationOnAndroid(@$bookings->vendor->deviceToken,$bodyV);
										}
								}
										
									if($this->request->data['status'] == 2){
											$response['msg'] = 'Booking completed successfully.';
											$bodyU['message'] = @$bookings->vendor->fullName.' has been completed successfully.';
											$bodyV['message'] = 'Booking accepted successfully.';
											if(strtolower(@$bookings->user->device) =='ios'){
												$this->sednIosPushNotification(@$bookings->user->deviceToken,$bodyU);
											}else{
												$this->sendNotificationOnAndroid(@$bookings->user->deviceToken,$bodyU);
											}
									}
										
									if($this->request->data['status'] == 3){
											$response['msg'] = 'Booking declined successfully.';
											$bodyV['message'] = 'Booking declined process completed.';
											if(strtolower(@$bookings->vendor->device) =='ios'){
												$this->sednIosPushNotification(@$bookings->vendor->deviceToken,$bodyV);
											}else{
												$this->sendNotificationOnAndroid(@$bookings->vendor->deviceToken,$bodyV);
											}
									}
										//$res = $this->productlist($products->userId);
										//$response['data'] = $res['data'];
							
						}else{
							$response['status'] = 'Fails';
							$response['msg'] = 'Booking already close or accepted by someone\'s else';
						}
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'bookingId, status and userId are required';
					}
					return  $response;
			}
	
	
	function bookingdetail($booking_id=NULL){
		$this->loadModel('Bookings');
		$this->loadModel('Users');
		
		$invoiceId = ($booking_id) ? $booking_id : $this->request->data('bookingId');
		
		if($invoiceId){
				$val =	$this->Bookings->find()->where(['Bookings.id'=>$this->request->data('bookingId')])->contain(['Vendors','Users', 'Categories', 'Uploads'])->first();
			//echo "<pre>";
			//print_r($val); die;
			if($val){
					
						$list['bookingID']						= ($val->id) ? $val->id : '';
						$list['userId']									= ($val->userId) ? $val->userId : '';
						$list['vendorId']							= ($val->vendorId) ? $val->vendorId : '';
						$list['bookingDate']				= ($val->bookingDate) ? $val->bookingDate : '';
						$list['address']								= ($val->address) ? $val->address : '';
						$list['couponCode']					= ($val->couponCode) ? $val->couponCode : '';
						$list['discountAmount']	= ($val->discountAmount) ? "$val->discountAmount" : "0";
						$list['TIP']												= ($val->TIP) ? "$val->TIP" : "0";
						$list['serviceAmount']		= ($val->serviceAmount) ? "$val->serviceAmount" : "0";
						$list['totalAmount']				= ($val->totalAmount) ? "$val->totalAmount" : "0";
						$list['salesTax']							= ($val->salesTax) ? "$val->salesTax" : "0";
						$list['transactionId']		= ($val->transactionId) ? $val->transactionId : '';
						$list['slote']										= ($val->slote) ? $val->slote : '';
						$list['notes']										= ($val->notes) ? $val->notes : '';
						
						$list['vendorType']					= ($val->vendorType) ? $val->vendorType : '';
						$list['latidude'] 						= (@$val->latitude) ? @$val->latitude : '';
						$list['longitude'] 					= (@$val->longitude) ? @$val->longitude : '';
						
						$list['status']										= ($val->status) ? $val->status : 0;
						
						$list['categoryId']					= ($val->categoryId) ? $val->categoryId : '';
						$list['categoryName']			= (@$val->category->name) ? @$val->category->name : '';
						$list['categoryImage']			= (@$val->category->image) ? $this->catPath.@$val->category->image : '';
						
						$list['userName']								= (@$val->user->fullName) ? @$val->user->fullName : '';
						$list['userEmail']							= (@$val->user->email) ? @$val->user->email : '';
						$list['userPhone']							= (@$val->user->contactNumber) ? @$val->user->contactNumber : '';
						$list['userAddress']					= (@$val->user->address) ? @$val->user->address : '';
						$list['userImage']							= (@$val->user->profile_picture) ? $this->profilePath.@$val->user->profile_picture : '';
						
						$list['vendorName']						= (@$val->vendor->fullName) ? @$val->vendor->fullName : '';
						$list['vendorEmail']					= (@$val->vendor->email) ? @$val->vendor->email : '';
						$list['vendorAddress']			= (@$val->vendor->address) ? $val->vendor->address : '';
						$list['vendorPhone']					= (@$val->vendor->contactNumber) ? @$val->vendor->contactNumber : '';
						$list['vendorAVGRating']	= (@$val->vendor->AVGRating) ? @$val->vendor->AVGRating : 0;
						$list['vendorImage']					= (@$val->vendor->profile_picture) ? $this->profilePath.@$val->vendor->profile_picture : '';
						
					
					$response['status'] = 'success';
					$response['historyList'] = $this->array_filter_recursive($list);
			}else{
					$response['status'] = 'Fail'; 	
					$response['msg'] = "Booking Id invalid.";	
			}
		}else{
			$response['status'] = "Fail";	
			$response['msg'] = "booking Id required";	
		}
		return $response;
	}
			
			
			
			
			function checkcoupon(){
				$this->loadModel('Coupons');
				if($this->request->data('userId') !='' && $this->request->data['code'] !=''){
					 $coupons = $this->Coupons->find()->where(['Coupons.code'=>$this->request->data['code']])->first();
						if($coupons){
							$response['status'] = 'success';
							$response['description'] = ($coupons->description) ? $coupons->description : '';
							$response['amount'] = ($coupons->amount) ? $coupons->amount : '0';
							$response['percentage'] = ($coupons->percentage) ? $coupons->percentage : '0';
							$response['msg'] = "Coupon applied successfully.";	
						}else{
							$response['status'] = "Fail";	
							$response['msg'] = "Invalid coupon code";	
						}
				}else{
					$response['status'] = "Fail";	
					$response['msg'] = "invoiceId required";	
				}
		return $response;
			}
			
			
		function setting(){
				if($this->request->data('vendorId') !='' && $this->request->data('startTime') !='' && $this->request->data('endTime') !='' && $this->request->data('brakeStartTime') !='' && $this->request->data('breakEndTime') !='' && $this->request->data('dayendarray') !='' ){
						$this->loadModel('Settings');
						$vendor = $this->Settings->find()->where(['Settings.userId'=>$this->request->data['vendorId']])->first();
						if(@$vendor->id ==''){
								$vendor = $this->Settings->newEntity();
						}
						$DATA['userId'] 								= $this->request->data('vendorId');
						$DATA['startTime'] 					= date('H:i',strtotime($this->request->data('startTime')));
						$DATA['endTime'] 							= date('H:i',strtotime($this->request->data('endTime')));
						$DATA['brakeStartTime'] = date('H:i',strtotime($this->request->data('brakeStartTime')));
						$DATA['breakEndTime'] 		= date('H:i',strtotime($this->request->data('breakEndTime')));
						$exp = explode(",", $this->request->data('dayendarray'));
						$DATA['MON'] = 1;
						$DATA['TUE'] = 1;
						$DATA['WED'] = 1;
						$DATA['THU'] = 1;
						$DATA['FRI'] = 1;
						$DATA['SAT'] = 1;
						$DATA['SUN'] = 1;
						foreach($exp as $val){
								if(strtolower($val) == 'mon'){
									$DATA['MON'] = 0;
								}elseif(strtolower($val) == 'tue'){
										$DATA['TUE'] = 0;
								}elseif(strtolower($val) == 'wed'){
										$DATA['WED'] = 0;
								}elseif(strtolower($val) == 'thu'){
										$DATA['THU'] = 0;
							}elseif(strtolower($val) == 'fri'){
								 $DATA['FRI'] = 0;
							}elseif(strtolower($val) == 'sat'){
								 $DATA['SAT'] = 0;
							}elseif(strtolower($val) == 'sun'){
								 $DATA['SUN'] = 0;
							}
					}
						$vendor = $this->Settings->patchEntity($vendor, $DATA, ['validate' => false]);
						$this->Settings->save($vendor);
					
					$response['status'] = 'success';
					$response['msg'] = 'Setting updated successfully';	
					
			}else{
				$response['status'] = 'Fail';
				$response['msg'] = 'vendorId, startTime, endTime, brakeStartTime, breakEndTime, and dayarray are required';	
			}
			return 	$response;
	}
			
			function getsetting(){
				$this->loadModel('Settings');
					if($this->request->data('vendorId') !=''){
							$vendor = $this->Settings->find()->where(['Settings.userId'=>$this->request->data('vendorId')])->first();
							if(@$vendor->id !=''){
								$DATA['id'] 													= $vendor->id;
								$DATA['startTime'] 						= date('h:i A',strtotime($vendor->startTime));
								$DATA['endTime'] 								= date('h:i A',strtotime($vendor->endTime));
								$DATA['brakeStartTime'] 	= date('h:i A',strtotime($vendor->brakeStartTime));
								$DATA['breakEndTime'] 			= date('h:i A',strtotime($vendor->breakEndTime));
								$DAY = array();
								if($vendor->MON == '0'){
									array_push($DAY,"Mon");
								}
								if($vendor->TUE == '0'){
										array_push($DAY,"Tue");
								}
								if($vendor->WED == '0'){
										array_push($DAY,"Wed");
								}
								if($vendor->THU == '0'){
										array_push($DAY,"Thu");
								}
								if($vendor->FRI == '0'){
										array_push($DAY,"Fri");
								}
								if($vendor->SAT == '0'){
										array_push($DAY,"Sat");
								}
								if($vendor->SUN == '0'){
										array_push($DAY,"Sun");
								}
								$DATA['dayendarray'] 				= implode(",", $DAY);
									
									$response['status'] = 'success';
									$response['data'] = $DATA;	
							}else{
									$response['status'] = 'success';
									$response['msg'] = 'Please fill all the fields.';
									$response['data'] = array();
							}
					}else{
						$response['status'] = 'Fail';
						$response['msg'] = 'vendorId is required';
					}
					return 	$response;
			}
			
			
			function vendorslot($vendorID=NULL, $DATE=NULL){
				$this->loadModel('Settings');
						$vendorId = ($vendorID) ? $vendorID : $this->request->data('vendorId');
						$Date = ($DATE) ? $DATE : $this->request->data('date');
						$DAY = strtoupper(date('D', strtotime($Date)));
						$slot = array();
						//$vendor = $this->Setting->find('first',array('conditions'=>array('Setting.userId'=>$vendorId, 'Setting.'.$DAY=>1)));
						$vendor = $this->Settings->find()->where(['Settings.userId'=>$vendorId, 'Settings.'.$DAY=>1])->first();
						if(@$vendor->id !=''){
								$totalSlote = explode(":", $vendor->endTime)[0] - explode(":", $vendor->startTime)[0];
								$j=0;
								for($i=1; $i<= $totalSlote; $i++ ){
										$STAT = date('h:i A',strtotime($vendor->startTime. " + ".$j."hour "));
										$END = date('h:i A',strtotime($vendor->startTime. " + ".$i."hour "));
										$slot[$i]['slot'] 		= $STAT."-".$END;
										$BST = strtotime($vendor->brakeStartTime);
										$BED = strtotime($vendor->breakEndTime);
										
										$CHEEKSLOT = date('H:i',strtotime($vendor->startTime. " + ".$j."hour "))."-".date('H:i',strtotime($vendor->startTime. " + ".$i."hour "));
										$status = $this->chkSlotbook($vendorId, $CHEEKSLOT,$Date);
										if($BST >= strtotime($STAT) && $BST <= strtotime($END)){
												$slot[$i]['status'] = 'Break Time';
										}else{
												$slot[$i]['status'] = $status;
										}
										
										$j++;
								}
								$response['status'] = 'success';
								$response['data'] = array_values($slot);
						}else{
							$vendor = $this->Settings->find()->where(['Settings.userId'=>$vendorId])->first();
							if(@$vendor->id !=''){
									$response['status'] = 'success';
									$response['msg'] = 'Off day for this vendor.';
									$response['data'] = array();
							}else{
								$response['status'] = 'success';
								$response['msg'] = 'Off day for this vendor.';
								$slot[0]['slot'] 		= "10:00 AM - 11:00 AM";
								$slot[0]['status'] = 'Available';
								
								$slot[1]['slot'] 		= "11:00 AM - 12:00 PM";
								$slot[1]['status'] = 'Available';
								
								$slot[2]['slot'] 		= "12:00 PM - 01:00 PM";
								$slot[2]['status'] = 'Available';
								
								$slot[3]['slot'] 		= "01:00 PM - 02:00 PM";
								$slot[3]['status'] = 'Available';
								
								$slot[4]['slot'] 		= "02:00 PM - 03:00 PM";
								$slot[4]['status'] = 'Available';
								
								$slot[5]['slot'] 		= "03:00 PM - 04:00 PM";
								$slot[5]['status'] = 'Available';
								
								$slot[6]['slot'] 		= "04:00 PM - 05:00 PM";
								$slot[6]['status'] = 'Available';
								
								$slot[7]['slot'] 		= "05:00 PM - 06:00 PM";
								$slot[7]['status'] = 'Available';
								$slot[8]['slot'] 		= "06:00 PM - 07:00 PM";
								$slot[8]['status'] = 'Available';
								$response['data'] = array_values($slot);
							}
						}
						return 	$response;
			}
			function chkSlotbook($vendorId,$slot,$Date){
					$this->loadModel('Bookings');
					$cond[] = ['Bookings.vendorId' => $vendorId];
					$cond[] = ['Bookings.bookingDate' => $Date];
					$cond[] = ['Bookings.slotTime' => $slot];
					$cond[] = ['Bookings.status' => 1];
					//echo "<pre>"; print_r($cond); die;				
					$booked = $this->Bookings->find()->where($cond)->count();
					if($booked > 0){
							$status = "Booked";
					}else{
						$exp = explode("-",$slot);
						$CHEC = $this->request->data['date']." ".$exp[0];
						$current = date('Y-m-d Hi:s');
							if($CHEC < $current){
								$status = "Booked";
							}else{
								$status = "Available";
							}
					}
					return $status; 
		}
		
		
		function submitreview(){
			if($this->request->data['reviewTo'] !='' && $this->request->data['reviewFrom'] !='' && $this->request->data['star'] != '' && $this->request->data['message'] !=''){
							$this->loadModel('Reviews');
							$this->loadModel('Users');
							$reviews = $this->Reviews->newEntity();
							$reviews = $this->Reviews->patchEntity($reviews, $this->request->data, ['validate' => false]);
							$reviews['created'] 	= date('Y-m-d H:i:s');
							$reviews['status'] 	= '1';
							$this->Reviews->save($reviews);
							
							//$avg = $this->Reviews->find('all')->where(['Reviews.reviewTo'=>$this->request->data['reviewTo']])->select(['averagerating' => $query->func()->avg('star')]);
							$query = $this->Reviews->find()->where(['Reviews.reviewTo'=>$this->request->data['reviewTo']]);
							$avg = $query->select(['averagerating' => $query->func()->avg('star')])->toArray();
							//echo "<pre>"; print_r($avg);
							//echo $avg[0]->averagerating;
							//die;
							
							$ABG['AVGRating'] = round($avg[0]->averagerating,2);
							$AVGR = round($avg[0]->averagerating,2);
							$articles = TableRegistry::get('Users');
							$query = $articles->query();
							$query->update()
								->set(['AVGRating' =>$AVGR])
								->where(['id' => $this->request->data['reviewTo']])
								->execute();
							
					$response['status'] = 'Success'; 
					$response['msg'] = "Review submitted successfully.";
			}else{
				$response['status'] = 'Fail'; 
				$response['msg'] = 'review_to, review_from, star and message are required.';
			}
			return $response;
	}
	
	function reviewlist($userId=NULL){
			$this->loadModel('User');
			$this->loadModel('Reviews');
				@$USERID = ($userId) ? $userId : $this->request->data('userId');
				@$pageNo = ($this->request->data['pageNo']) ? $this->request->data['pageNo'] : 1;
					if($USERID !=''){
							$this->paginate = [
							'limit' => '10',//$limit,
							'order' => [
									'Reviews.id' => 'desc'
									],
							'page'=>$pageNo,
								'contain' => ['Reviewfroms']
							];
							$keyword = $this->request->query('keyword');
							$condition[] = ['Reviews.reviewTo'=>$USERID, 'Reviews.status'=>1];
							$userservices = array();    
							$query = $this->Reviews->find('all')->where($condition);
							$totalCount =  $query->count();
							if($pageNo <= ceil($totalCount/10)){
									$userservices = $this->paginate($query);
									$userservices = $userservices->toArray();
							}
							$Darray = array();
							$i=0;
							//echo "<pre>"; print_r($userservices); die;
							foreach($userservices as $val){
								$Darray[$i]['reviewId'] 						= ($val->id) ? $val->id : '';
								$Darray[$i]['message'] 							= ($val->message) ? $val->message : '';
								$Darray[$i]['star'] 										= ($val->star) ? $val->star : '';
								
								$Darray[$i]['userId'] 								= (@$val->reviewfrom->id) ? @$val->reviewfrom->id : '';
								$Darray[$i]['userName'] 						= (@$val->reviewfrom->fullName) ? @$val->reviewfrom->fullName : '';
								$Darray[$i]['userAddress'] 			= (@$val->reviewfrom->address) ? @$val->reviewfrom->address : '';
								$Darray[$i]['profile_picture']= (@$val->reviewfrom->profile_picture) ? $this->profilePath.@$val->reviewfrom->profile_picture : '';
								$i++;
							}
							$response['status'] = "success";
							$response['response'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
							$response['ONESTAR'] = $this->Reviews->find('all')->where(['Reviews.reviewTo'=>$USERID,'Reviews.star'=>1])->count();
							$response['ONETWO'] = $this->Reviews->find('all')->where(['Reviews.reviewTo'=>$USERID,'Reviews.star'=>2])->count();
							$response['ONETHREE'] = $this->Reviews->find('all')->where(['Reviews.reviewTo'=>$USERID,'Reviews.star'=>3])->count();
							$response['ONEFOUR'] = $this->Reviews->find('all')->where(['Reviews.reviewTo'=>$USERID,'Reviews.star'=>4])->count();
							$response['ONEFIVE'] = $this->Reviews->find('all')->where(['Reviews.reviewTo'=>$USERID,'Reviews.star'=>5])->count();
							
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID is required.';
				}
				return  $response;
		}
		
		
		
		function addaddress(){
			if($this->request->data['userId'] !='' && $this->request->data['firstName'] !='' && $this->request->data['mobile'] != '' && $this->request->data['address'] !=''){
							$this->loadModel('Address');
							$reviews = $this->Address->newEntity();
							$reviews = $this->Address->patchEntity($reviews, $this->request->data, ['validate' => false]);
							$reviews['created'] 	= date('Y-m-d H:i:s');
							$reviews['status'] 	= '1';
							$this->Address->save($reviews);
							
					$response['status'] = 'Success'; 
					$response['msg'] = "Addess added successfully.";
			}else{
				$response['status'] = 'Fail'; 
				$response['msg'] = 'userId, firstName, mobile and address are required.';
			}
			return $response;
	}
	
	function addresslist($userId=NULL){
			$this->loadModel('Address');
				@$USERID = ($userId) ? $userId : $this->request->data('userId');
				@$pageNo = ($this->request->data['pageNo']) ? $this->request->data['pageNo'] : 1;
					if($USERID !=''){
							$this->paginate = [
							'limit' => '10',//$limit,
							'order' => [
									'Address.id' => 'desc'
									],
							'page'=>$pageNo,
								//'contain' => ['Users']
							];
							$keyword = $this->request->query('keyword');
							$condition[] = ['Address.userId'=>$USERID, 'Address.status'=>1];
							$userservices = array();    
							$query = $this->Address->find('all')->where($condition);
							$totalCount =  $query->count();
							if($pageNo <= ceil($totalCount/10)){
									$userservices = $this->paginate($query);
									$userservices = $userservices->toArray();
							}
							$Darray = array();
							$i=0;
							//echo "<pre>"; print_r($userservices); die;
							foreach($userservices as $val){
								$Darray[$i]['addressId'] 						= ($val->id) ? $val->id : '';
								$Darray[$i]['firstName'] 						= ($val->firstName) ? $val->firstName : '';
								$Darray[$i]['lastName'] 							= ($val->lastName) ? $val->lastName : '';
								$Darray[$i]['mobile'] 									= ($val->mobile) ? $val->mobile : '';
								$Darray[$i]['address'] 								= ($val->address) ? $val->address : '';
								$Darray[$i]['City'] 											= ($val->City) ? $val->City : '';
								$Darray[$i]['state'] 										= ($val->state) ? $val->state : '';
								$Darray[$i]['Zipcode'] 								= ($val->Zipcode) ? $val->Zipcode : '';
								$Darray[$i]['deliveryType'] 			= ($val->deliveryType) ? $val->deliveryType : '';
							
								$i++;
							}
							$response['status'] = "success";
							$response['data'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
							
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID is required.';
				}
				return  $response;
		}
		
		private function editaddress(){
		$this->loadModel('Address');
		if($this->request->data('addressId') !='' && $this->request->data('userId') !=''){
			$address = $this->Address->find()->where(['Address.id' => $this->request->data('addressId'),'Address.userId' => $this->request->data('userId')])->first();
			if(!empty($address)){
				//@unset($this->request->data('email'));
				$address = $this->Address->patchEntity($address, $this->request->data, ['validate' => false]);
				if ($this->Address->save($address)) {
							$response['status'] = 'success';
							$response['msg'] = 'Address updated successfully.';
							$DD = $this->addresslist($address->userId);
							$response['data'] = $DD['data'];
				}
			}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'addressId does not exist';
			}
		}else{
			$response['status'] = 'Fails';
			$response['msg'] = 'addressId,UserID is required';
		}
		return  $response;
	}
	
		
	function logout(){
		$articles = TableRegistry::get('Users');
			$query = $articles->query();
			$query->update()
				->set(['deviceToken'=>'','lastLogin'=>date('Y-m-d H:i:s')])
				->where(['id' => $this->request->data['userId']])
				->execute();
				$response['status'] = 'success';
				return  $response;
	}
	
	function getwallet(){
		if($this->request->data['userId'] !=''){
			$this->loadModel('Users');
			$users = $this->Users->find()->where(['Users.id'=>$this->request->data['userId']])->select(['wallet'])->first();
			$response['status'] = "success";
			$response['wallet'] = ($users->wallet) ? $users->wallet : 0;
			//pr($users); die;
		}else{
				$response['status'] = 'Fails';
				$response['msg'] = 'USERID, foodId are required.';
		}
				return  $response;
	}
	
	
	function test(){
		$array = array("apple"=>'34', '2'=>["YES"=>null, '11'=>'TEST', '08'=>NULL,'1'=>Null,'25'=>'Good'], '21'=>null, 'ye'=>["rr"=>null, '15'=>'TEST', '03'=>'rr','12'=>Null,'25'=>'Good'], -5, "orange"=>'er', '10'=>Null);
		
		$response['status'] = $array;
		$response['data'] = $this->array_filter_recursive($array);
		return  $response;
	}
	
	
	function array_filter_recursive($array) {
		foreach ($array as $key => & $value) {
			if (is_array($value)) {
				$value = $this->array_filter_recursive($value);
			}
			else {
				if ( ! is_null($value)) {
				}
				else {
					$array[$key] = '';
				}
			}
		}
		return $array;
	}
	
	function help(){
				
				$data['phone'] 	= '180-234-5678';
				$data['eamil'] = 'support@labordispatch.com';
				$response['status'] = 'success';
				$response['data'] = $data;
				return  $response;
		
	}
	
	function learninglist($userId=NULL, $PAGENO=NULL){
					$this->loadModel('Learnings');
					$UserID = ($userId)? $userId : @$this->request->data['userId'];
					//$TYPE = ($type) ? $type : $this->request->data['type'];
					@$pageNo = ($PAGENO) ? $PAGENO : ($this->request->data['pageNo']) ? $this->request->data['pageNo'] : '1';
					if($pageNo !=''){
						$this->paginate = [
							'limit' => '10',//$limit,
							'order' => [
									'Learnings.id' => 'desc'
									],
							'page'=>$pageNo,
							//'contain' => ['Users']
							];
						$keyword = $this->request->query('keyword');
						$condition[] = ['Learnings.status'=>1];
						if(@$categoryId != ''){
							$condition = [];
						}        
						$query = $this->Learnings->find('all')->where($condition);
						$totalCount =  $query->count();
						$userservices =array();
						if($pageNo <= ceil($totalCount/10)){
								$userservices = $this->paginate($query);
								$userservices = $userservices->toArray();
						}
						$Darray = array();
						$i=0;
						foreach($userservices as $val){
								$Darray[$i]['learningId'] 						= (@$val->id) ? @$val->id : '';
								$Darray[$i]['name'] 												= (@$val->name) ? @$val->name : '';
								$Darray[$i]['description'] 					= (@$val->description) ? @$val->description : '';
								$Darray[$i]['displayImage'] 				= (@$val->image) ? $this->LearningPath.@$val->image : '';
								$Darray[$i]['video'] 											= (@$val->video) ? $this->LearningPath.@$val->video : '';
								$Darray[$i]['created'] 									= (@$val->created) ? date('Y-m-d H:i:s', strtotime($val->created)) : '';
								$Darray[$i]['totalViewed'] 					= (@$val->totalViewed) ? @$val->totalViewed : '0';
								$i++;
						}
						$response['status'] = "success";
						$response['data'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'userId and pageNo are required.';
					}
					return  $response;
		}
		
		function addcart(){
				if($this->request->data['userId'] !='' && $this->request->data['productId'] !='' &&  $this->request->data['quantity'] !=''){
						$this->loadModel('Carts');
							$reviews = $this->Carts->find()->where(['Carts.userId'=>$this->request->data['userId'], 'Carts.productId'=>$this->request->data['productId']])->first();
							if(@$reviews->id ==''){
								$reviews = $this->Carts->newEntity();
							}
							$reviews = $this->Carts->patchEntity($reviews, $this->request->data, ['validate' => false]);
							$reviews['created'] 	= date('Y-m-d H:i:s');
							$reviews['status'] 	= '1';
							$this->Carts->save($reviews);
						$response['status'] = "success";
						$response['msg'] = 'Added to cart successfully.';
						//$FD = $this->getcarts($this->request->data['userId']);
						$response['totalCartItem'] = $cartLists = $this->Carts->find()->where(['Carts.userId'=>$this->request->data['userId']])->count();
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID, productId and quantity are required.';
				}
				return  $response;
		}
		
		function deletecarts(){
				if($this->request->data['userId'] !='' && $this->request->data['productId'] !=''){
						$this->loadModel('Carts');
						$reviews = $this->Carts->find()->where(['Carts.userId'=>$this->request->data['userId'], 'Carts.productId'=>$this->request->data['productId']])->first();
							if(@$reviews->id !=''){
								$this->Carts->delete($reviews);
								$response['status'] = "success";
								$response['msg'] = 'Item deleted successfully.';
								$response['totalCartItem'] = $cartLists = $this->Carts->find()->where(['Carts.userId'=>$this->request->data['userId']])->count();
							}else{
								$response['status'] = 'Fails';
								$response['msg'] = 'Food no longer available.';
							}
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID, foodId are required.';
				}
				return  $response;
		}
		
		function deleteallcarts(){
				if($this->request->data['userId'] !=''){
						$this->loadModel('Carts');
								$this->Carts->deleteAll(['Carts.userId'=>$this->request->data['userId']]);
								$response['status'] = "success";
								$response['msg'] = 'Item deleted successfully.';
								$response['totalCartItem'] = $cartLists = $this->Carts->find()->where(['Carts.userId'=>$this->request->data['userId']])->count();
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID, foodId are required.';
				}
				return  $response;
		}
		
		function getcarts(){
			$this->loadModel('Carts');
				if($this->request->data['userId'] !=''){
					$cartLists = $this->Carts->find()->where(['Carts.userId'=>$this->request->data['userId']])->contain(['Products'])->toArray();
					$i=0;
					$array = array();
					foreach($cartLists as $cartList){
							$array[$i]['userId'] 							= $cartList->userId;
							$array[$i]['quantity'] 					= $cartList->quantity;
							$array[$i]['productId'] 				= $cartList->productId;
							$array[$i]['productName'] 		= (@$cartList->product->productName) ? @$cartList->product->productName : '';
							$array[$i]['productImage'] 	= (@$cartList->image) ? $this->productPath.@$cartList->product->image : '';
							$array[$i]['productPrice'] 	= (@$cartList->product->price) ? @$cartList->product->price : '';
							$array[$i]['productSKU'] 			= (@$cartList->product->SKU) ? @$cartList->product->SKU : '';
							$i++;
					}
					$response['status'] = "success";
					$response['data'] = $array;
					$response['TotalCartItem'] = count($cartLists);
				}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID, foodId are required.';
				}
				return  $response;
		}
		
	function productlist($userId=NULL){
			$this->loadModel('Products');
				@$USERID = ($userId) ? $userId : $this->request->data('userId');
				@$pageNo = ($this->request->data['pageNo']) ? $this->request->data['pageNo'] : 1;
					if($pageNo !=''){
							$this->paginate = [
							'limit' => '10',//$limit,
							'order' => ['Products.id' => 'desc'],
							'page'=>$pageNo,
								//'contain' => ['Reviewfroms']
							];
							$keyword = @$this->request->data('keyword');
							if($keyword !=''){
								$condition[] = ['OR'=>[
																																['Products.productName LIKE'=>'%'.$keyword.'%'],
																																['Products.price LIKE'=>'%'.$keyword.'%'],
																																['Products.SKU LIKE'=>'%'.$keyword.'%'],
																																['Products.description LIKE'=>'%'.$keyword.'%'],
																														]
																							];
							}
							$condition[] = ['Products.status'=>1];
							$userservices = array();    
							$query = $this->Products->find('all')->where($condition);
							$totalCount =  $query->count();
							if($pageNo <= ceil($totalCount/10)){
									$userservices = $this->paginate($query);
									$userservices = $userservices->toArray();
							}
							$Darray = array();
							$i=0;
							//echo "<pre>"; print_r($userservices); die;
							foreach($userservices as $val){
								$Darray[$i]['productId'] 						= ($val->id) ? $val->id : '';
								$Darray[$i]['productName'] 				= ($val->productName) ? $val->productName : '';
								$Darray[$i]['price'] 										= ($val->price) ? $val->price : '';
								$Darray[$i]['quantity'] 							= ($val->quantity) ? $val->quantity : '';
								$Darray[$i]['SKU'] 												= ($val->SKU) ? $val->SKU : '';
								$Darray[$i]['description'] 				= (@$val->description) ? @$val->description : '';
								$Darray[$i]['image']											= (@$val->image) ? $this->productPath.@$val->image : '';
								$i++;
							}
							$response['status'] = "success";
							$response['data'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
							
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'pageNo is required.';
				}
				return  $response;
		}
		
		function productdetails($productId=NULL){
			$this->loadModel('Products');
				@$USERID = ($productId) ? $productId : $this->request->data('productId');
				@$pageNo = ($this->request->data['pageNo']) ? $this->request->data['pageNo'] : 1;
					if($pageNo !=''){
							$this->paginate = [
							'limit' => '10',//$limit,
							'order' => ['Products.id' => 'desc'],
							'page'=>$pageNo,
								//'contain' => ['Reviewfroms']
							];
							$keyword = $this->request->query('keyword');
							$condition[] = ['Products.status'=>1];
							$userservices = array();    
							$query = $this->Products->find('all')->where($condition);
							$totalCount =  $query->count();
							if($pageNo <= ceil($totalCount/10)){
									$userservices = $this->paginate($query);
									$userservices = $userservices->toArray();
							}
							$Darray = array();
							$i=0;
							//echo "<pre>"; print_r($userservices); die;
							foreach($userservices as $val){
								$Darray[$i]['productId'] 						= ($val->id) ? $val->id : '';
								$Darray[$i]['productName'] 				= ($val->productName) ? $val->productName : '';
								$Darray[$i]['price'] 										= ($val->price) ? $val->price : '';
								$Darray[$i]['quantity'] 							= ($val->quantity) ? $val->quantity : '';
								$Darray[$i]['SKU'] 												= ($val->SKU) ? $val->SKU : '';
								$Darray[$i]['description'] 				= (@$val->description) ? @$val->description : '';
								$Darray[$i]['image']= (@$val->image) ? $this->productPath.@$val->image : '';
								$i++;
							}
							$response['status'] = "success";
							$response['data'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
							
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'pageNo is required.';
				}
				return  $response;
		}
		
	
	
	function addpurchese(){
		//pr($this->request->data); die('yesysss');
		$this->loadModel('Purchases');
		if($this->request->data['userId'] !='' && @$this->request->data['productDetails'] !='' && @$this->request->data['transactionId'] !='' && @$this->request->data['ShippingAddress'] !='' && @$this->request->data['ShippingZipcode'] !=''){
					$reviews = $this->Purchases->newEntity();
					$reviews = $this->Purchases->patchEntity($reviews, $this->request->data, ['validate' => false]);
					$reviews['created'] 	= date('Y-m-d H:i:s');
					$reviews['status'] 	= '1';
					$this->Purchases->save($reviews);
							
				$response['status'] = 'success';
				$response['msg'] = "Purchese successfully.";
				$DDD = $this->purcheslist($this->request->data['userId']);
				$response['data'] = $DDD['data'];
		}else{
				$response['status'] = 'Fail';
				$response['msg'] = 'userId, transactionId, productDetails and shippingAddress are required';	
		}
		return 	$response;
	}
	
	
		
		function purcheslist($userId=NULL){
			$this->loadModel('Purchases');
				@$USERID = ($userId) ? $userId : $this->request->data('userId');
				@$pageNo = ($this->request->data['pageNo']) ? $this->request->data['pageNo'] : 1;
				@$TYPE = (@$this->request->data['userType']) ? @$this->request->data['userType'] : '';
				@$STATUS = (@$this->request->data['status']) ? @$this->request->data['status'] : '';
					if($USERID !=''){
							$this->paginate = [
							'limit' => '10',//$limit,
							'order' => ['Purchases.id' => 'desc'],
							'page'=>$pageNo,
							];
							$keyword = $this->request->query('keyword');
							if($TYPE !=''){
								$condition[] = ['Purchases.assignDriver'=>$USERID];
							}else{
								$condition[] = ['Purchases.userId'=>$USERID];
							}
							if($STATUS !=''){
								$condition[] = ['Purchases.status'=>$STATUS];
							}
							$userservices = array();    
							$query = $this->Purchases->find('all')->where($condition);
							$totalCount =  $query->count();
							if($pageNo <= ceil($totalCount/10)){
									$userservices = $this->paginate($query);
									$userservices = $userservices->toArray();
							}
							$Darray = array();
							$i=0;
							//echo "<pre>"; print_r($userservices); die;
							foreach($userservices as $val){
								$Darray[$i]['purcheseId'] 					= ($val->id) ? $val->id : '';
								$Darray[$i]['transactionId'] 		= ($val->transactionId) ? $val->transactionId : '';
								$Darray[$i]['productDetails'] 		= ($val->productDetails) ? json_decode($val->productDetails) : array();
								$Darray[$i]['totalAmount']	= ($val->totalAmount) ? $val->totalAmount : '';
								$Darray[$i]['ShippingName']	= ($val->ShippingName) ? $val->ShippingName : '';
								$Darray[$i]['shippingAddress']	= ($val->ShippingAddress) ? $val->ShippingAddress : '';
								$Darray[$i]['shippingCity']				= ($val->ShippingCity) ? $val->ShippingCity : '';
								$Darray[$i]['shippingState']			= ($val->ShippingState) ? $val->ShippingState : '';
								$Darray[$i]['shippingCountry']	= ($val->ShippingCountry) ? $val->ShippingCountry : '';
								$Darray[$i]['shippingZipcode']	= ($val->ShippingZipcode) ? $val->ShippingZipcode : '';
								$Darray[$i]['ShippingPhone']	= ($val->ShippingPhone) ? $val->ShippingPhone : '';
								$Darray[$i]['status']										= ($val->status) ? $val->status : '';
								$Darray[$i]['created']									= ($val->created) ? date('Y-m-d H:i:s', strtotime($val->created)) : '';
								$i++;
							}
							$response['status'] = "success";
							$response['data'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'USERID is required.';
				}
				return  $response;
		}
		
		
		function purchedetail($purcheseId=NULL){
			$this->loadModel('Purchases');
			$this->loadModel('Products');
				@$USERID = ($userId) ? $userId : $this->request->data('userId');
				@$purcheseD = ($purcheseId) ? $purcheseId : $this->request->data['purcheseId'];
			
					if($purcheseD !=''){
						
							$userservices = array();    
							$val = $this->Purchases->find()->where(['Purchases.id'=>$purcheseD])->contain(['Users'])->first();
							$Darray = array();
							$product = array();
							$i=0;
								$Darray['purcheseId'] 					= ($val->id) ? $val->id : '';
								$Darray['transactionId'] 		= ($val->transactionId) ? $val->transactionId : '';
								
								$DET 		= ($val->productDetails) ? json_decode($val->productDetails) : array();
								if(!empty($DET)){
									foreach($DET as $prod){
										$details = $this->Products->find()->where(['Products.id'=>$prod->productId])->first();
										$product[$i]['price'] 						= $prod->price;
										$product[$i]['Quantity'] 			= $prod->Quantity;
										$product[$i]['productId'] 		= (@$details->id) ? @$details->id : '';
										$product[$i]['productName'] = (@$details->productName) ? @$details->productName : '';
										$product[$i]['image'] 						= (@$details->image) ? $this->productPath.@$details->image : '';
										$product[$i]['description'] = (@$details->description) ? @$details->description : '';
										$product[$i]['SKU'] 								= (@$details->SKU) ? @$details->SKU : '';
										$i++;
									}
								}
								$Darray['productDetails'] = $product;
								$Darray['totalAmount']					= ($val->totalAmount) ? $val->totalAmount : '';
								$Darray['ShippingName']				= ($val->ShippingName) ? $val->ShippingName : '';
								$Darray['shippingAddress']	= ($val->ShippingAddress) ? $val->ShippingAddress : '';
								$Darray['shippingCity']				= ($val->ShippingCity) ? $val->ShippingCity : '';
								$Darray['shippingState']			= ($val->ShippingState) ? $val->ShippingState : '';
								$Darray['shippingCountry']	= ($val->ShippingCountry) ? $val->ShippingCountry : '';
								$Darray['shippingZipcode']	= ($val->ShippingZipcode) ? $val->ShippingZipcode : '';
								$Darray['ShippingPhone']	= ($val->ShippingPhone) ? $val->ShippingPhone : '';
								
								$Darray['driverName']					= (@$val->user->fullName) ? @$val->user->fullName : '';
								$Darray['driverPhone']				= (@$val->user->contactNumber) ? @$val->user->contactNumber : '';
								$Darray['driverImage']				= (@$val->user->profile_picture) ? $this->profilePath.@$val->user->profile_picture : '';
								if(strpos(@$val->user->profile_picture, "http") !== false){
									$Darray['driverImage'] = @$val->user->profile_picture;
								}
								$Darray['status']										= ($val->status) ? $val->status : '';
								$Darray['created']									= ($val->created) ? date('Y-m-d H:i:s', strtotime($val->created)) : '';
							
							$response['status'] = "success";
							$response['data'] = ($Darray) ? $this->array_filter_recursive($Darray) : array();
					}else{
						$response['status'] = 'Fails';
						$response['msg'] = 'purcheseD is required.';
				}
				return  $response;
		}
		
	function checknotifination($id=NULL){
		$deciceId = ($id) ? $id : $this->request->data['deviceToken'];
		$body['message'] = 'YES HELLO';
		$this->sendNotificationOnAndroid($deciceId,$body);
	}
	//(array) $object;  //Object to array();
	//function array_filter_recursive_object($array) {
	function array_filter_recursive_object(array &$array){
		foreach ($array as $key => &$value) {
		  if (is_array($value)) {
			$value = $this->array_filter_recursive_object($value);
		  }
		  if (empty($value)) {
			$array[$key] = '';
		  }
		}
		return $array;
	}

	
	
	
}