<?php
namespace App\Model\Table;

use Cake\ORM\Table;
use Cake\Validation\Validator;
use Cake\Auth\DefaultPasswordHasher;
//use Cake\ORM\RulesChecker;
 
class LearningsTable extends Table
{
    public function initialize(array $config)
    {
        
		$this->belongsTo('Users', [
            'className' => 'Users',
            //'bindingKey' => ['clientId'],
			'foreignKey' => ['userId']
        ]);
		$this->belongsTo('Events', [
            'className' => 'Events',
            //'bindingKey' => ['clientId'],
			'foreignKey' => ['eventId']
        ]);
    }
    
    public function validationCustomer(Validator $validator)
    {
       
		$validator->notEmpty('name', 'Please enter name.');
        $validator->add('image', [      
				'image' => [                    
					'rule'=>  function($value){
						$ext = explode(".", $value);
						$extension = strtolower(end($ext));
						
						if (in_array(trim($extension), array('jpg', 'jpeg', 'png', 'gif'))) {							
							return true;
						}
						return false;
					},
					'message'=>'Please select jpg, jpeg, gif and png only.',
                ]
		])->notEmpty('image');
		$validator->add('video', [      
				'video' => [                    
					'rule'=>  function($value){
						$ext = explode(".", $value);
						$extension = strtolower(end($ext));
						
						if (in_array(trim($extension), array('mp4'))) {							
							return true;
						}
						return false;
					},
					'message'=>'Please select mp4 only.',
                ]
		])->notEmpty('video');
        return $validator;
    }
    
    
    
	
    
    
    
    
    
    
   

}
